/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs
#define yylval          CISAlval
#define yychar          CISAchar

/* First part of user prologue.  */
#line 27 "CISA.y"

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"


//VISA_Type variable_declaration_and_type_check(char *var, Common_ISA_Var_Class type);
void CISAerror(CISA_IR_Builder* builder, char const* msg);
int  yylex();
extern int CISAlineno;


static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value);
static VISA_Align AlignBytesToVisaAlignment(int bytes);
static int DataTypeSizeOf(VISA_Type type);
static bool ParseEMask(CISA_IR_Builder* pBuilder, const char* sym, VISA_EMask_Ctrl &emask);




//
// check if the cond is true.
// if cond is false, then print errorMessage (syntax error) and YYABORT
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR_AT(LINE,...)\
  {pBuilder->RecordParseError(LINE, __VA_ARGS__); YYABORT;}
#define PARSE_ERROR(...)\
    PARSE_ERROR_AT(CISAlineno, __VA_ARGS__)

// Use this to wrap API calls that return false, nullptr, or 0 on failure
// It's assumed that the API call reported the parse error
#define ABORT_ON_FAIL(X) \
    do \
        if (!(X)) \
            YYABORT;\
    while (0)
#ifdef _DEBUG
#define TRACE(str) fprintf(CISAout, str)
#else
#define TRACE(str)
#endif

std::deque<const char*> switchLabels;
char * switch_label_array[32];
std::vector<VISA_opnd*> RTRWOperands;
int num_parameters;

VISA_RawOpnd* rawOperandArray[16];

// global var for non-kernel attribute option.
// The var needs to be cleared before each use.
std::vector<attr_gen_struct*> AttrOptVar;

#ifdef _MSC_VER
#pragma warning(disable:4065; disable:4267)
#endif


#line 146 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "CISA.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ALIGN_KEYWORD = 3,              /* ALIGN_KEYWORD  */
  YYSYMBOL_ATOMIC_SUB_OP = 4,              /* ATOMIC_SUB_OP  */
  YYSYMBOL_DIRECTIVE_DECL = 5,             /* DIRECTIVE_DECL  */
  YYSYMBOL_DIRECTIVE_FUNC = 6,             /* DIRECTIVE_FUNC  */
  YYSYMBOL_DIRECTIVE_FUNCDECL = 7,         /* DIRECTIVE_FUNCDECL  */
  YYSYMBOL_DIRECTIVE_GLOBAL_FUNC = 8,      /* DIRECTIVE_GLOBAL_FUNC  */
  YYSYMBOL_DIRECTIVE_IMPLICIT = 9,         /* DIRECTIVE_IMPLICIT  */
  YYSYMBOL_DIRECTIVE_INPUT = 10,           /* DIRECTIVE_INPUT  */
  YYSYMBOL_DIRECTIVE_KERNEL = 11,          /* DIRECTIVE_KERNEL  */
  YYSYMBOL_DIRECTIVE_KERNEL_ATTR = 12,     /* DIRECTIVE_KERNEL_ATTR  */
  YYSYMBOL_DIRECTIVE_PARAMETER = 13,       /* DIRECTIVE_PARAMETER  */
  YYSYMBOL_DIRECTIVE_VERSION = 14,         /* DIRECTIVE_VERSION  */
  YYSYMBOL_ALIAS_EQ = 15,                  /* ALIAS_EQ  */
  YYSYMBOL_ALIGN_EQ = 16,                  /* ALIGN_EQ  */
  YYSYMBOL_ATTR_EQ = 17,                   /* ATTR_EQ  */
  YYSYMBOL_OFFSET_EQ = 18,                 /* OFFSET_EQ  */
  YYSYMBOL_NUM_ELTS_EQ = 19,               /* NUM_ELTS_EQ  */
  YYSYMBOL_V_NAME_EQ = 20,                 /* V_NAME_EQ  */
  YYSYMBOL_SIZE_EQ = 21,                   /* SIZE_EQ  */
  YYSYMBOL_V_TYPE_EQ_G = 22,               /* V_TYPE_EQ_G  */
  YYSYMBOL_V_TYPE_EQ_P = 23,               /* V_TYPE_EQ_P  */
  YYSYMBOL_V_TYPE_EQ_A = 24,               /* V_TYPE_EQ_A  */
  YYSYMBOL_V_TYPE_EQ_S = 25,               /* V_TYPE_EQ_S  */
  YYSYMBOL_V_TYPE_EQ_T = 26,               /* V_TYPE_EQ_T  */
  YYSYMBOL_CPS = 27,                       /* CPS  */
  YYSYMBOL_NON_UNIFORM_SAMPLER = 28,       /* NON_UNIFORM_SAMPLER  */
  YYSYMBOL_PIXEL_NULL_MASK = 29,           /* PIXEL_NULL_MASK  */
  YYSYMBOL_RAW_SENDC_STRING = 30,          /* RAW_SENDC_STRING  */
  YYSYMBOL_RAW_SENDSC_EOT_STRING = 31,     /* RAW_SENDSC_EOT_STRING  */
  YYSYMBOL_RAW_SENDSC_STRING = 32,         /* RAW_SENDSC_STRING  */
  YYSYMBOL_RAW_SENDS_EOT_STRING = 33,      /* RAW_SENDS_EOT_STRING  */
  YYSYMBOL_RAW_SENDS_STRING = 34,          /* RAW_SENDS_STRING  */
  YYSYMBOL_RAW_SEND_STRING = 35,           /* RAW_SEND_STRING  */
  YYSYMBOL_SAT = 36,                       /* SAT  */
  YYSYMBOL_SRCMOD_ABS = 37,                /* SRCMOD_ABS  */
  YYSYMBOL_SRCMOD_NEG = 38,                /* SRCMOD_NEG  */
  YYSYMBOL_SRCMOD_NEGABS = 39,             /* SRCMOD_NEGABS  */
  YYSYMBOL_SRCMOD_NOT = 40,                /* SRCMOD_NOT  */
  YYSYMBOL_ITYPE = 41,                     /* ITYPE  */
  YYSYMBOL_DECL_DATA_TYPE = 42,            /* DECL_DATA_TYPE  */
  YYSYMBOL_DFTYPE = 43,                    /* DFTYPE  */
  YYSYMBOL_FTYPE = 44,                     /* FTYPE  */
  YYSYMBOL_HFTYPE = 45,                    /* HFTYPE  */
  YYSYMBOL_VTYPE = 46,                     /* VTYPE  */
  YYSYMBOL_COND_MOD = 47,                  /* COND_MOD  */
  YYSYMBOL_LANGLE = 48,                    /* LANGLE  */
  YYSYMBOL_RANGLE = 49,                    /* RANGLE  */
  YYSYMBOL_LBRACK = 50,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 51,                    /* RBRACK  */
  YYSYMBOL_IND_LBRACK = 52,                /* IND_LBRACK  */
  YYSYMBOL_LPAREN = 53,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 54,                    /* RPAREN  */
  YYSYMBOL_LBRACE = 55,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 56,                    /* RBRACE  */
  YYSYMBOL_DOT = 57,                       /* DOT  */
  YYSYMBOL_COMMA = 58,                     /* COMMA  */
  YYSYMBOL_SEMI = 59,                      /* SEMI  */
  YYSYMBOL_COLON = 60,                     /* COLON  */
  YYSYMBOL_SLASH = 61,                     /* SLASH  */
  YYSYMBOL_PERCENT = 62,                   /* PERCENT  */
  YYSYMBOL_EQUALS = 63,                    /* EQUALS  */
  YYSYMBOL_PLUS = 64,                      /* PLUS  */
  YYSYMBOL_MINUS = 65,                     /* MINUS  */
  YYSYMBOL_TIMES = 66,                     /* TIMES  */
  YYSYMBOL_AMP = 67,                       /* AMP  */
  YYSYMBOL_CIRC = 68,                      /* CIRC  */
  YYSYMBOL_PIPE = 69,                      /* PIPE  */
  YYSYMBOL_TILDE = 70,                     /* TILDE  */
  YYSYMBOL_BANG = 71,                      /* BANG  */
  YYSYMBOL_QUESTION = 72,                  /* QUESTION  */
  YYSYMBOL_LEQ = 73,                       /* LEQ  */
  YYSYMBOL_GEQ = 74,                       /* GEQ  */
  YYSYMBOL_EQ = 75,                        /* EQ  */
  YYSYMBOL_NEQ = 76,                       /* NEQ  */
  YYSYMBOL_SHL = 77,                       /* SHL  */
  YYSYMBOL_SHRS = 78,                      /* SHRS  */
  YYSYMBOL_SHRZ = 79,                      /* SHRZ  */
  YYSYMBOL_LABEL = 80,                     /* LABEL  */
  YYSYMBOL_IDENT = 81,                     /* IDENT  */
  YYSYMBOL_BUILTIN_NULL = 82,              /* BUILTIN_NULL  */
  YYSYMBOL_BUILTIN = 83,                   /* BUILTIN  */
  YYSYMBOL_STRING_LIT = 84,                /* STRING_LIT  */
  YYSYMBOL_NEWLINE = 85,                   /* NEWLINE  */
  YYSYMBOL_RTWRITE_OPTION = 86,            /* RTWRITE_OPTION  */
  YYSYMBOL_MEDIA_MODE = 87,                /* MEDIA_MODE  */
  YYSYMBOL_OWORD_MODIFIER = 88,            /* OWORD_MODIFIER  */
  YYSYMBOL_SAMPLER_CHANNEL = 89,           /* SAMPLER_CHANNEL  */
  YYSYMBOL_CHANNEL_OUTPUT = 90,            /* CHANNEL_OUTPUT  */
  YYSYMBOL_EXECMODE = 91,                  /* EXECMODE  */
  YYSYMBOL_CNTRL = 92,                     /* CNTRL  */
  YYSYMBOL_FENCE_OPTIONS = 93,             /* FENCE_OPTIONS  */
  YYSYMBOL_ADDR_ADD_OP = 94,               /* ADDR_ADD_OP  */
  YYSYMBOL_UNARY_LOGIC_OP = 95,            /* UNARY_LOGIC_OP  */
  YYSYMBOL_BINARY_LOGIC_OP = 96,           /* BINARY_LOGIC_OP  */
  YYSYMBOL_TERNARY_LOGIC_OP = 97,          /* TERNARY_LOGIC_OP  */
  YYSYMBOL_QUATERNARY_LOGIC_OP = 98,       /* QUATERNARY_LOGIC_OP  */
  YYSYMBOL_SEL_OP = 99,                    /* SEL_OP  */
  YYSYMBOL_MIN_OP = 100,                   /* MIN_OP  */
  YYSYMBOL_MAX_OP = 101,                   /* MAX_OP  */
  YYSYMBOL_ANTI_TRIG_OP = 102,             /* ANTI_TRIG_OP  */
  YYSYMBOL_MATH2_OP = 103,                 /* MATH2_OP  */
  YYSYMBOL_MATH3_OP = 104,                 /* MATH3_OP  */
  YYSYMBOL_ARITH2_OP = 105,                /* ARITH2_OP  */
  YYSYMBOL_ARITH3_OP = 106,                /* ARITH3_OP  */
  YYSYMBOL_ARITH4_OP = 107,                /* ARITH4_OP  */
  YYSYMBOL_ARITH4_OP2 = 108,               /* ARITH4_OP2  */
  YYSYMBOL_CMP_OP = 109,                   /* CMP_OP  */
  YYSYMBOL_SVM_OP = 110,                   /* SVM_OP  */
  YYSYMBOL_SVM_SCATTER_OP = 111,           /* SVM_SCATTER_OP  */
  YYSYMBOL_SVM_GATHER4SCALED_OP = 112,     /* SVM_GATHER4SCALED_OP  */
  YYSYMBOL_SVM_SCATTER4SCALED_OP = 113,    /* SVM_SCATTER4SCALED_OP  */
  YYSYMBOL_SVM_ATOMIC_OP = 114,            /* SVM_ATOMIC_OP  */
  YYSYMBOL_OWORD_OP = 115,                 /* OWORD_OP  */
  YYSYMBOL_MEDIA_OP = 116,                 /* MEDIA_OP  */
  YYSYMBOL_SCATTER_OP = 117,               /* SCATTER_OP  */
  YYSYMBOL_SCATTER_TYPED_OP = 118,         /* SCATTER_TYPED_OP  */
  YYSYMBOL_SCATTER_SCALED_OP = 119,        /* SCATTER_SCALED_OP  */
  YYSYMBOL_SCATTER4_SCALED_OP = 120,       /* SCATTER4_SCALED_OP  */
  YYSYMBOL_BARRIER_OP = 121,               /* BARRIER_OP  */
  YYSYMBOL_SBARRIER_SIGNAL = 122,          /* SBARRIER_SIGNAL  */
  YYSYMBOL_SBARRIER_WAIT = 123,            /* SBARRIER_WAIT  */
  YYSYMBOL_DWORD_ATOMIC_OP = 124,          /* DWORD_ATOMIC_OP  */
  YYSYMBOL_TYPED_ATOMIC_OP = 125,          /* TYPED_ATOMIC_OP  */
  YYSYMBOL_SAMPLE_OP = 126,                /* SAMPLE_OP  */
  YYSYMBOL_SAMPLE_UNORM_OP = 127,          /* SAMPLE_UNORM_OP  */
  YYSYMBOL_VME_IME_OP = 128,               /* VME_IME_OP  */
  YYSYMBOL_VME_SIC_OP = 129,               /* VME_SIC_OP  */
  YYSYMBOL_VME_FBR_OP = 130,               /* VME_FBR_OP  */
  YYSYMBOL_BRANCH_OP = 131,                /* BRANCH_OP  */
  YYSYMBOL_RET_OP = 132,                   /* RET_OP  */
  YYSYMBOL_IFCALL = 133,                   /* IFCALL  */
  YYSYMBOL_FCALL = 134,                    /* FCALL  */
  YYSYMBOL_FADDR = 135,                    /* FADDR  */
  YYSYMBOL_SWITCHJMP_OP = 136,             /* SWITCHJMP_OP  */
  YYSYMBOL_MOVS_OP = 137,                  /* MOVS_OP  */
  YYSYMBOL_SETP_OP = 138,                  /* SETP_OP  */
  YYSYMBOL_MOV_OP = 139,                   /* MOV_OP  */
  YYSYMBOL_FILE_OP = 140,                  /* FILE_OP  */
  YYSYMBOL_LOC_OP = 141,                   /* LOC_OP  */
  YYSYMBOL_CACHE_FLUSH_OP = 142,           /* CACHE_FLUSH_OP  */
  YYSYMBOL_WAIT_OP = 143,                  /* WAIT_OP  */
  YYSYMBOL_FENCE_GLOBAL_OP = 144,          /* FENCE_GLOBAL_OP  */
  YYSYMBOL_FENCE_LOCAL_OP = 145,           /* FENCE_LOCAL_OP  */
  YYSYMBOL_FENCE_SW_OP = 146,              /* FENCE_SW_OP  */
  YYSYMBOL_YIELD_OP = 147,                 /* YIELD_OP  */
  YYSYMBOL_SAMPLE_3D_OP = 148,             /* SAMPLE_3D_OP  */
  YYSYMBOL_LOAD_3D_OP = 149,               /* LOAD_3D_OP  */
  YYSYMBOL_SAMPLE4_3D_OP = 150,            /* SAMPLE4_3D_OP  */
  YYSYMBOL_RESINFO_OP_3D = 151,            /* RESINFO_OP_3D  */
  YYSYMBOL_SAMPLEINFO_OP_3D = 152,         /* SAMPLEINFO_OP_3D  */
  YYSYMBOL_RTWRITE_OP_3D = 153,            /* RTWRITE_OP_3D  */
  YYSYMBOL_URBWRITE_OP_3D = 154,           /* URBWRITE_OP_3D  */
  YYSYMBOL_LIFETIME_START_OP = 155,        /* LIFETIME_START_OP  */
  YYSYMBOL_LIFETIME_END_OP = 156,          /* LIFETIME_END_OP  */
  YYSYMBOL_AVS_OP = 157,                   /* AVS_OP  */
  YYSYMBOL_PRED_CNTL = 158,                /* PRED_CNTL  */
  YYSYMBOL_F32_LIT = 159,                  /* F32_LIT  */
  YYSYMBOL_F64_LIT = 160,                  /* F64_LIT  */
  YYSYMBOL_DEC_LIT = 161,                  /* DEC_LIT  */
  YYSYMBOL_HEX_LIT = 162,                  /* HEX_LIT  */
  YYSYMBOL_BUILTIN_SIZEOF = 163,           /* BUILTIN_SIZEOF  */
  YYSYMBOL_BUILTIN_DISPATCH_SIMD_SIZE = 164, /* BUILTIN_DISPATCH_SIMD_SIZE  */
  YYSYMBOL_YYACCEPT = 165,                 /* $accept  */
  YYSYMBOL_Listing = 166,                  /* Listing  */
  YYSYMBOL_ListingHeader = 167,            /* ListingHeader  */
  YYSYMBOL_Statements = 168,               /* Statements  */
  YYSYMBOL_Newlines = 169,                 /* Newlines  */
  YYSYMBOL_NewlinesOpt = 170,              /* NewlinesOpt  */
  YYSYMBOL_Statement = 171,                /* Statement  */
  YYSYMBOL_Scope = 172,                    /* Scope  */
  YYSYMBOL_ScopeStart = 173,               /* ScopeStart  */
  YYSYMBOL_ScopeEnd = 174,                 /* ScopeEnd  */
  YYSYMBOL_IdentOrStringLit = 175,         /* IdentOrStringLit  */
  YYSYMBOL_DirectiveKernel = 176,          /* DirectiveKernel  */
  YYSYMBOL_DirectiveGlobalFunction = 177,  /* DirectiveGlobalFunction  */
  YYSYMBOL_DirectiveVersion = 178,         /* DirectiveVersion  */
  YYSYMBOL_DirectiveDecl = 179,            /* DirectiveDecl  */
  YYSYMBOL_DeclFunction = 180,             /* DeclFunction  */
  YYSYMBOL_DeclVariable = 181,             /* DeclVariable  */
  YYSYMBOL_DeclAddress = 182,              /* DeclAddress  */
  YYSYMBOL_DeclPredicate = 183,            /* DeclPredicate  */
  YYSYMBOL_DeclSampler = 184,              /* DeclSampler  */
  YYSYMBOL_VNameEqOpt = 185,               /* VNameEqOpt  */
  YYSYMBOL_DeclSurface = 186,              /* DeclSurface  */
  YYSYMBOL_DirectiveInput = 187,           /* DirectiveInput  */
  YYSYMBOL_DirectiveImplicitInput = 188,   /* DirectiveImplicitInput  */
  YYSYMBOL_InputOffset = 189,              /* InputOffset  */
  YYSYMBOL_InputSize = 190,                /* InputSize  */
  YYSYMBOL_DirectiveParameter = 191,       /* DirectiveParameter  */
  YYSYMBOL_DirectiveAttr = 192,            /* DirectiveAttr  */
  YYSYMBOL_DirectiveFunc = 193,            /* DirectiveFunc  */
  YYSYMBOL_AlignAttrOpt = 194,             /* AlignAttrOpt  */
  YYSYMBOL_Align = 195,                    /* Align  */
  YYSYMBOL_AliasAttrOpt = 196,             /* AliasAttrOpt  */
  YYSYMBOL_OneAttr = 197,                  /* OneAttr  */
  YYSYMBOL_AttrOpt = 198,                  /* AttrOpt  */
  YYSYMBOL_GenAttrOpt = 199,               /* GenAttrOpt  */
  YYSYMBOL_Instruction = 200,              /* Instruction  */
  YYSYMBOL_Label = 201,                    /* Label  */
  YYSYMBOL_LogicInstruction = 202,         /* LogicInstruction  */
  YYSYMBOL_UnaryLogicInstruction = 203,    /* UnaryLogicInstruction  */
  YYSYMBOL_MathInstruction_2OPND = 204,    /* MathInstruction_2OPND  */
  YYSYMBOL_MathInstruction_3OPND = 205,    /* MathInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_2OPND = 206,   /* ArithInstruction_2OPND  */
  YYSYMBOL_ArithInstruction_3OPND = 207,   /* ArithInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_4OPND = 208,   /* ArithInstruction_4OPND  */
  YYSYMBOL_AntiTrigInstruction = 209,      /* AntiTrigInstruction  */
  YYSYMBOL_AddrAddInstruction = 210,       /* AddrAddInstruction  */
  YYSYMBOL_SetpInstruction = 211,          /* SetpInstruction  */
  YYSYMBOL_SelInstruction = 212,           /* SelInstruction  */
  YYSYMBOL_MinInstruction = 213,           /* MinInstruction  */
  YYSYMBOL_MaxInstruction = 214,           /* MaxInstruction  */
  YYSYMBOL_MovInstruction = 215,           /* MovInstruction  */
  YYSYMBOL_MovsInstruction = 216,          /* MovsInstruction  */
  YYSYMBOL_CmpInstruction = 217,           /* CmpInstruction  */
  YYSYMBOL_MediaInstruction = 218,         /* MediaInstruction  */
  YYSYMBOL_MediaInstructionPlaneID = 219,  /* MediaInstructionPlaneID  */
  YYSYMBOL_ScatterInstruction = 220,       /* ScatterInstruction  */
  YYSYMBOL_ScatterTypedInstruction = 221,  /* ScatterTypedInstruction  */
  YYSYMBOL_Scatter4ScaledInstruction = 222, /* Scatter4ScaledInstruction  */
  YYSYMBOL_ScatterScaledInstruction = 223, /* ScatterScaledInstruction  */
  YYSYMBOL_SynchronizationInstruction = 224, /* SynchronizationInstruction  */
  YYSYMBOL_DwordAtomicInstruction = 225,   /* DwordAtomicInstruction  */
  YYSYMBOL_TypedAtomicInstruction = 226,   /* TypedAtomicInstruction  */
  YYSYMBOL_Atomic16Opt = 227,              /* Atomic16Opt  */
  YYSYMBOL_SampleUnormInstruction = 228,   /* SampleUnormInstruction  */
  YYSYMBOL_SampleInstruction = 229,        /* SampleInstruction  */
  YYSYMBOL_Sample3dInstruction = 230,      /* Sample3dInstruction  */
  YYSYMBOL_CPSEnableOpt = 231,             /* CPSEnableOpt  */
  YYSYMBOL_NonUniformSamplerEnableOpt = 232, /* NonUniformSamplerEnableOpt  */
  YYSYMBOL_Load3dInstruction = 233,        /* Load3dInstruction  */
  YYSYMBOL_Gather43dInstruction = 234,     /* Gather43dInstruction  */
  YYSYMBOL_PixelNullMaskEnableOpt = 235,   /* PixelNullMaskEnableOpt  */
  YYSYMBOL_ResInfo3dInstruction = 236,     /* ResInfo3dInstruction  */
  YYSYMBOL_SampleInfo3dInstruction = 237,  /* SampleInfo3dInstruction  */
  YYSYMBOL_RTWriteOperandParse = 238,      /* RTWriteOperandParse  */
  YYSYMBOL_RTWriteInstruction = 239,       /* RTWriteInstruction  */
  YYSYMBOL_RTWriteModeOpt = 240,           /* RTWriteModeOpt  */
  YYSYMBOL_URBWriteInstruction = 241,      /* URBWriteInstruction  */
  YYSYMBOL_AVSInstruction = 242,           /* AVSInstruction  */
  YYSYMBOL_VMEInstruction = 243,           /* VMEInstruction  */
  YYSYMBOL_OwordInstruction = 244,         /* OwordInstruction  */
  YYSYMBOL_SvmInstruction = 245,           /* SvmInstruction  */
  YYSYMBOL_AtomicBitwidthOpt = 246,        /* AtomicBitwidthOpt  */
  YYSYMBOL_SwitchLabels = 247,             /* SwitchLabels  */
  YYSYMBOL_BranchInstruction = 248,        /* BranchInstruction  */
  YYSYMBOL_FILE = 249,                     /* FILE  */
  YYSYMBOL_LOC = 250,                      /* LOC  */
  YYSYMBOL_RawSendInstruction = 251,       /* RawSendInstruction  */
  YYSYMBOL_LifetimeStartInst = 252,        /* LifetimeStartInst  */
  YYSYMBOL_LifetimeEndInst = 253,          /* LifetimeEndInst  */
  YYSYMBOL_RawSendsInstruction = 254,      /* RawSendsInstruction  */
  YYSYMBOL_NullaryInstruction = 255,       /* NullaryInstruction  */
  YYSYMBOL_OwordModifier = 256,            /* OwordModifier  */
  YYSYMBOL_Predicate = 257,                /* Predicate  */
  YYSYMBOL_PredSign = 258,                 /* PredSign  */
  YYSYMBOL_PredCtrlOpt = 259,              /* PredCtrlOpt  */
  YYSYMBOL_SatModOpt = 260,                /* SatModOpt  */
  YYSYMBOL_SrcModifier = 261,              /* SrcModifier  */
  YYSYMBOL_ConditionalModifier = 262,      /* ConditionalModifier  */
  YYSYMBOL_VecDstOperand_A = 263,          /* VecDstOperand_A  */
  YYSYMBOL_VecDstOperand_G = 264,          /* VecDstOperand_G  */
  YYSYMBOL_VecDstOperand_G_I = 265,        /* VecDstOperand_G_I  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A_AO = 266, /* VecSrcOperand_G_I_IMM_A_AO  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A = 267,  /* VecSrcOperand_G_I_IMM_A  */
  YYSYMBOL_VecSrcOperand_G_I_IMM = 268,    /* VecSrcOperand_G_I_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM = 269,      /* VecSrcOperand_G_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM_AO = 270,   /* VecSrcOperand_G_IMM_AO  */
  YYSYMBOL_VecSrcOperand_G_A = 271,        /* VecSrcOperand_G_A  */
  YYSYMBOL_VecSrcOperand_G_A_AO = 272,     /* VecSrcOperand_G_A_AO  */
  YYSYMBOL_VecSrcOperand_G = 273,          /* VecSrcOperand_G  */
  YYSYMBOL_VMEOpndIME = 274,               /* VMEOpndIME  */
  YYSYMBOL_VMEOpndFBR = 275,               /* VMEOpndFBR  */
  YYSYMBOL_SrcStateOperand = 276,          /* SrcStateOperand  */
  YYSYMBOL_DstStateOperand = 277,          /* DstStateOperand  */
  YYSYMBOL_RawOperand = 278,               /* RawOperand  */
  YYSYMBOL_RawOperandNonNull = 279,        /* RawOperandNonNull  */
  YYSYMBOL_RawOperandOffsetSuffix = 280,   /* RawOperandOffsetSuffix  */
  YYSYMBOL_RawOperandArray = 281,          /* RawOperandArray  */
  YYSYMBOL_DstAddrOperand = 282,           /* DstAddrOperand  */
  YYSYMBOL_DstGeneralOperand = 283,        /* DstGeneralOperand  */
  YYSYMBOL_DstIndirectOperand = 284,       /* DstIndirectOperand  */
  YYSYMBOL_SrcAddrOfOperand = 285,         /* SrcAddrOfOperand  */
  YYSYMBOL_AddrOfVar = 286,                /* AddrOfVar  */
  YYSYMBOL_SrcAddrOperand = 287,           /* SrcAddrOperand  */
  YYSYMBOL_SrcGeneralOperand = 288,        /* SrcGeneralOperand  */
  YYSYMBOL_SrcImmOperand = 289,            /* SrcImmOperand  */
  YYSYMBOL_FloatLit = 290,                 /* FloatLit  */
  YYSYMBOL_DoubleFloatLit = 291,           /* DoubleFloatLit  */
  YYSYMBOL_SrcIndirectOperand = 292,       /* SrcIndirectOperand  */
  YYSYMBOL_DstRegion = 293,                /* DstRegion  */
  YYSYMBOL_SrcRegionDirect = 294,          /* SrcRegionDirect  */
  YYSYMBOL_SrcRegionIndirect = 295,        /* SrcRegionIndirect  */
  YYSYMBOL_IndirectVarAccess = 296,        /* IndirectVarAccess  */
  YYSYMBOL_TwoDimOffset = 297,             /* TwoDimOffset  */
  YYSYMBOL_PredVar = 298,                  /* PredVar  */
  YYSYMBOL_AddrVarAccess = 299,            /* AddrVarAccess  */
  YYSYMBOL_AddrVarAccessWithWidth = 300,   /* AddrVarAccessWithWidth  */
  YYSYMBOL_SIMDMode = 301,                 /* SIMDMode  */
  YYSYMBOL_ElemNum = 302,                  /* ElemNum  */
  YYSYMBOL_ExecSize = 303,                 /* ExecSize  */
  YYSYMBOL_ExecSizeInt = 304,              /* ExecSizeInt  */
  YYSYMBOL_Var = 305,                      /* Var  */
  YYSYMBOL_VarNonNull = 306,               /* VarNonNull  */
  YYSYMBOL_IntExp = 307,                   /* IntExp  */
  YYSYMBOL_IntExpCond = 308,               /* IntExpCond  */
  YYSYMBOL_IntExpAND = 309,                /* IntExpAND  */
  YYSYMBOL_IntExpXOR = 310,                /* IntExpXOR  */
  YYSYMBOL_IntExpOR = 311,                 /* IntExpOR  */
  YYSYMBOL_IntExpCmp = 312,                /* IntExpCmp  */
  YYSYMBOL_IntExpRel = 313,                /* IntExpRel  */
  YYSYMBOL_IntExpNRA = 314,                /* IntExpNRA  */
  YYSYMBOL_IntExpShift = 315,              /* IntExpShift  */
  YYSYMBOL_IntExpAdd = 316,                /* IntExpAdd  */
  YYSYMBOL_IntExpMul = 317,                /* IntExpMul  */
  YYSYMBOL_IntExpUnr = 318,                /* IntExpUnr  */
  YYSYMBOL_IntExpPrim = 319,               /* IntExpPrim  */
  YYSYMBOL_DataType = 320,                 /* DataType  */
  YYSYMBOL_DataTypeIntOrVector = 321       /* DataTypeIntOrVector  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2554

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  165
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  157
/* YYNRULES -- Number of rules.  */
#define YYNRULES  356
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  882

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   419


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   513,   513,   518,   520,   520,   522,   522,   523,   523,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   541,   542,   543,   547,   551,   554,   554,   561,   569,
     577,   584,   585,   586,   587,   588,   589,   591,   598,   606,
     614,   621,   625,   625,   628,   636,   641,   653,   660,   668,
     668,   669,   676,   682,   686,   690,   694,   699,   705,   705,
     707,   711,   717,   725,   731,   736,   741,   747,   751,   755,
     761,   766,   772,   776,   786,   787,   788,   789,   790,   791,
     792,   793,   794,   795,   796,   797,   798,   799,   800,   801,
     802,   803,   804,   805,   806,   807,   808,   809,   810,   811,
     812,   813,   814,   815,   816,   817,   818,   819,   820,   821,
     822,   823,   824,   825,   826,   827,   828,   829,   830,   833,
     837,   843,   848,   854,   862,   868,   875,   882,   889,   896,
     907,   914,   924,   933,   943,   950,   957,   965,   974,   981,
     987,   993,   999,  1017,  1024,  1034,  1042,  1049,  1056,  1065,
    1074,  1083,  1091,  1094,  1097,  1102,  1109,  1117,  1118,  1124,
    1133,  1141,  1149,  1161,  1161,  1163,  1163,  1166,  1179,  1191,
    1191,  1194,  1202,  1210,  1213,  1217,  1222,  1232,  1232,  1236,
    1244,  1256,  1272,  1278,  1291,  1299,  1306,  1312,  1318,  1324,
    1331,  1332,  1339,  1342,  1345,  1352,  1356,  1360,  1366,  1371,
    1378,  1383,  1388,  1394,  1401,  1408,  1414,  1420,  1428,  1436,
    1444,  1453,  1458,  1463,  1468,  1473,  1478,  1483,  1488,  1493,
    1493,  1499,  1504,  1509,  1509,  1511,  1511,  1514,  1514,  1517,
    1518,  1519,  1520,  1522,  1522,  1527,  1528,  1530,  1531,  1535,
    1536,  1539,  1540,  1543,  1544,  1545,  1548,  1549,  1552,  1553,
    1554,  1557,  1558,  1561,  1562,  1564,  1576,  1583,  1591,  1599,
    1618,  1630,  1637,  1649,  1654,  1661,  1666,  1674,  1682,  1688,
    1693,  1715,  1719,  1725,  1735,  1743,  1750,  1760,  1766,  1773,
    1777,  1782,  1786,  1792,  1793,  1800,  1808,  1809,  1815,  1825,
    1833,  1842,  1860,  1874,  1877,  1888,  1899,  1904,  1909,  1917,
    1926,  1938,  1952,  1954,  1965,  1977,  1983,  1991,  2000,  2000,
    2001,  2001,  2004,  2006,  2007,  2009,  2010,  2012,  2013,  2015,
    2016,  2018,  2019,  2020,  2022,  2023,  2024,  2025,  2026,  2043,
    2046,  2047,  2048,  2049,  2051,  2052,  2053,  2055,  2056,  2061,
    2066,  2068,  2069,  2070,  2071,  2075,  2076,  2078,  2082,  2086,
    2092,  2101,  2102,  2103,  2104,  2106,  2107
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ALIGN_KEYWORD",
  "ATOMIC_SUB_OP", "DIRECTIVE_DECL", "DIRECTIVE_FUNC",
  "DIRECTIVE_FUNCDECL", "DIRECTIVE_GLOBAL_FUNC", "DIRECTIVE_IMPLICIT",
  "DIRECTIVE_INPUT", "DIRECTIVE_KERNEL", "DIRECTIVE_KERNEL_ATTR",
  "DIRECTIVE_PARAMETER", "DIRECTIVE_VERSION", "ALIAS_EQ", "ALIGN_EQ",
  "ATTR_EQ", "OFFSET_EQ", "NUM_ELTS_EQ", "V_NAME_EQ", "SIZE_EQ",
  "V_TYPE_EQ_G", "V_TYPE_EQ_P", "V_TYPE_EQ_A", "V_TYPE_EQ_S",
  "V_TYPE_EQ_T", "CPS", "NON_UNIFORM_SAMPLER", "PIXEL_NULL_MASK",
  "RAW_SENDC_STRING", "RAW_SENDSC_EOT_STRING", "RAW_SENDSC_STRING",
  "RAW_SENDS_EOT_STRING", "RAW_SENDS_STRING", "RAW_SEND_STRING", "SAT",
  "SRCMOD_ABS", "SRCMOD_NEG", "SRCMOD_NEGABS", "SRCMOD_NOT", "ITYPE",
  "DECL_DATA_TYPE", "DFTYPE", "FTYPE", "HFTYPE", "VTYPE", "COND_MOD",
  "LANGLE", "RANGLE", "LBRACK", "RBRACK", "IND_LBRACK", "LPAREN", "RPAREN",
  "LBRACE", "RBRACE", "DOT", "COMMA", "SEMI", "COLON", "SLASH", "PERCENT",
  "EQUALS", "PLUS", "MINUS", "TIMES", "AMP", "CIRC", "PIPE", "TILDE",
  "BANG", "QUESTION", "LEQ", "GEQ", "EQ", "NEQ", "SHL", "SHRS", "SHRZ",
  "LABEL", "IDENT", "BUILTIN_NULL", "BUILTIN", "STRING_LIT", "NEWLINE",
  "RTWRITE_OPTION", "MEDIA_MODE", "OWORD_MODIFIER", "SAMPLER_CHANNEL",
  "CHANNEL_OUTPUT", "EXECMODE", "CNTRL", "FENCE_OPTIONS", "ADDR_ADD_OP",
  "UNARY_LOGIC_OP", "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP",
  "QUATERNARY_LOGIC_OP", "SEL_OP", "MIN_OP", "MAX_OP", "ANTI_TRIG_OP",
  "MATH2_OP", "MATH3_OP", "ARITH2_OP", "ARITH3_OP", "ARITH4_OP",
  "ARITH4_OP2", "CMP_OP", "SVM_OP", "SVM_SCATTER_OP",
  "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP", "SVM_ATOMIC_OP",
  "OWORD_OP", "MEDIA_OP", "SCATTER_OP", "SCATTER_TYPED_OP",
  "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP", "BARRIER_OP",
  "SBARRIER_SIGNAL", "SBARRIER_WAIT", "DWORD_ATOMIC_OP", "TYPED_ATOMIC_OP",
  "SAMPLE_OP", "SAMPLE_UNORM_OP", "VME_IME_OP", "VME_SIC_OP", "VME_FBR_OP",
  "BRANCH_OP", "RET_OP", "IFCALL", "FCALL", "FADDR", "SWITCHJMP_OP",
  "MOVS_OP", "SETP_OP", "MOV_OP", "FILE_OP", "LOC_OP", "CACHE_FLUSH_OP",
  "WAIT_OP", "FENCE_GLOBAL_OP", "FENCE_LOCAL_OP", "FENCE_SW_OP",
  "YIELD_OP", "SAMPLE_3D_OP", "LOAD_3D_OP", "SAMPLE4_3D_OP",
  "RESINFO_OP_3D", "SAMPLEINFO_OP_3D", "RTWRITE_OP_3D", "URBWRITE_OP_3D",
  "LIFETIME_START_OP", "LIFETIME_END_OP", "AVS_OP", "PRED_CNTL", "F32_LIT",
  "F64_LIT", "DEC_LIT", "HEX_LIT", "BUILTIN_SIZEOF",
  "BUILTIN_DISPATCH_SIMD_SIZE", "$accept", "Listing", "ListingHeader",
  "Statements", "Newlines", "NewlinesOpt", "Statement", "Scope",
  "ScopeStart", "ScopeEnd", "IdentOrStringLit", "DirectiveKernel",
  "DirectiveGlobalFunction", "DirectiveVersion", "DirectiveDecl",
  "DeclFunction", "DeclVariable", "DeclAddress", "DeclPredicate",
  "DeclSampler", "VNameEqOpt", "DeclSurface", "DirectiveInput",
  "DirectiveImplicitInput", "InputOffset", "InputSize",
  "DirectiveParameter", "DirectiveAttr", "DirectiveFunc", "AlignAttrOpt",
  "Align", "AliasAttrOpt", "OneAttr", "AttrOpt", "GenAttrOpt",
  "Instruction", "Label", "LogicInstruction", "UnaryLogicInstruction",
  "MathInstruction_2OPND", "MathInstruction_3OPND",
  "ArithInstruction_2OPND", "ArithInstruction_3OPND",
  "ArithInstruction_4OPND", "AntiTrigInstruction", "AddrAddInstruction",
  "SetpInstruction", "SelInstruction", "MinInstruction", "MaxInstruction",
  "MovInstruction", "MovsInstruction", "CmpInstruction",
  "MediaInstruction", "MediaInstructionPlaneID", "ScatterInstruction",
  "ScatterTypedInstruction", "Scatter4ScaledInstruction",
  "ScatterScaledInstruction", "SynchronizationInstruction",
  "DwordAtomicInstruction", "TypedAtomicInstruction", "Atomic16Opt",
  "SampleUnormInstruction", "SampleInstruction", "Sample3dInstruction",
  "CPSEnableOpt", "NonUniformSamplerEnableOpt", "Load3dInstruction",
  "Gather43dInstruction", "PixelNullMaskEnableOpt", "ResInfo3dInstruction",
  "SampleInfo3dInstruction", "RTWriteOperandParse", "RTWriteInstruction",
  "RTWriteModeOpt", "URBWriteInstruction", "AVSInstruction",
  "VMEInstruction", "OwordInstruction", "SvmInstruction",
  "AtomicBitwidthOpt", "SwitchLabels", "BranchInstruction", "FILE", "LOC",
  "RawSendInstruction", "LifetimeStartInst", "LifetimeEndInst",
  "RawSendsInstruction", "NullaryInstruction", "OwordModifier",
  "Predicate", "PredSign", "PredCtrlOpt", "SatModOpt", "SrcModifier",
  "ConditionalModifier", "VecDstOperand_A", "VecDstOperand_G",
  "VecDstOperand_G_I", "VecSrcOperand_G_I_IMM_A_AO",
  "VecSrcOperand_G_I_IMM_A", "VecSrcOperand_G_I_IMM",
  "VecSrcOperand_G_IMM", "VecSrcOperand_G_IMM_AO", "VecSrcOperand_G_A",
  "VecSrcOperand_G_A_AO", "VecSrcOperand_G", "VMEOpndIME", "VMEOpndFBR",
  "SrcStateOperand", "DstStateOperand", "RawOperand", "RawOperandNonNull",
  "RawOperandOffsetSuffix", "RawOperandArray", "DstAddrOperand",
  "DstGeneralOperand", "DstIndirectOperand", "SrcAddrOfOperand",
  "AddrOfVar", "SrcAddrOperand", "SrcGeneralOperand", "SrcImmOperand",
  "FloatLit", "DoubleFloatLit", "SrcIndirectOperand", "DstRegion",
  "SrcRegionDirect", "SrcRegionIndirect", "IndirectVarAccess",
  "TwoDimOffset", "PredVar", "AddrVarAccess", "AddrVarAccessWithWidth",
  "SIMDMode", "ElemNum", "ExecSize", "ExecSizeInt", "Var", "VarNonNull",
  "IntExp", "IntExpCond", "IntExpAND", "IntExpXOR", "IntExpOR",
  "IntExpCmp", "IntExpRel", "IntExpNRA", "IntExpShift", "IntExpAdd",
  "IntExpMul", "IntExpUnr", "IntExpPrim", "DataType",
  "DataTypeIntOrVector", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419
};
#endif

#define YYPACT_NINF (-832)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-346)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -68,  -832,    28,   -46,    54,  -832,  -832,  -105,   -68,  -832,
      17,  2331,   -80,    13,    37,     4,    37,    20,    47,    37,
      55,    76,    88,  -832,  -832,   136,   163,   136,   124,   131,
     181,  -832,  -832,  -832,   152,   159,   220,   197,   229,   206,
     136,   136,   136,   212,   150,  -832,   683,   219,   223,  -832,
    -832,   224,   228,   237,   238,   231,   -68,  -832,  -832,  2119,
    -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,
    -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,
    -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,
    -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,
    -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,
    -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,
    -832,  2400,  -832,   235,  -832,  -832,  -832,  -832,  -832,   303,
     303,  -832,   259,   302,  -832,   197,   -19,   197,  -832,   136,
      32,  -832,   136,   273,   169,   136,   279,   247,   177,   197,
    -832,  -832,  -832,   203,  -832,    32,   197,   -23,    32,   197,
     197,  -832,  -832,  -832,  -832,  -832,  -832,   144,   -30,   144,
     144,  -832,  -832,    64,   155,   -28,  -832,   197,  -832,  -832,
    -832,  -832,  -832,  -832,   273,     3,  -832,  -832,  -832,   136,
     136,  -832,  -832,   197,  1898,  -832,  -832,  2272,   136,   181,
     181,   181,   181,   136,   305,   305,   305,   305,   305,   305,
     305,   305,   305,   305,   305,   305,   305,   136,   285,   254,
     255,   341,   257,   290,   261,   347,   348,   136,   136,   136,
     136,   305,   324,   324,   324,   268,   136,   314,   338,   342,
     343,   344,   144,   190,   302,    12,   144,   349,   202,  -832,
    -832,   310,   307,   164,  -832,  -832,   315,   -23,   197,   -23,
     203,  -832,  -832,  -832,   321,   197,   144,   197,  -832,   124,
     209,   197,   197,   313,   203,   316,   203,  -832,   317,   318,
     203,  -832,  -832,  -832,   327,    42,   319,   197,    32,  -832,
      63,    32,   144,  -832,  -832,   325,  -832,   115,   320,   329,
    -832,    72,    18,  -832,    85,    14,  -832,   140,  -832,  -832,
    -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,   301,  -832,
     273,   335,  -832,  -832,  -832,   197,   197,   197,  -832,  -832,
     -68,  -832,   222,   181,   181,   181,   181,   225,  -832,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
     136,   136,   -23,   239,   136,   136,   328,   136,   256,   136,
     332,   332,    37,  -832,    32,   309,   136,  -832,   359,   326,
     330,  -832,   136,   260,   377,   144,   144,   144,   144,  -832,
     361,   349,  -832,  -832,  -832,  -832,  -832,  -832,  -832,   345,
    -832,   262,   197,  -832,   528,  -832,  -832,   368,  -832,  -832,
     367,   144,    32,    32,    42,   -21,   369,   321,  -832,   144,
    -832,   100,    32,   366,   535,   197,   371,   210,   197,   269,
     203,   270,   203,   -26,  -832,    32,   203,   144,   100,  -832,
     327,    29,  -832,   379,  -832,  -832,   380,   144,  -832,  -832,
     144,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,   144,   144,   144,   395,   335,
     144,  -832,   203,   203,    32,   378,   292,   181,   181,   181,
     181,   294,   -23,   -23,   -23,   -23,   -23,   -23,   -23,   -23,
     -23,   -23,   -23,   -23,   -23,   -23,   394,    32,    32,   296,
     136,   197,   136,   197,   297,   136,   136,  -832,   298,   299,
     -23,  -832,   434,   136,   136,   197,   304,   144,   349,   349,
     444,   444,   385,  -832,  -832,   413,  -832,  -832,  -832,  -832,
    -832,   144,   144,   415,    32,    32,  -832,   144,   144,   100,
     174,   132,  -832,  -832,  -832,  -832,  -832,   203,   144,   183,
      32,    32,    32,  -832,   316,   203,   203,   317,    32,   416,
     203,  -832,  -832,   144,  -832,   414,   203,   422,  -832,  -832,
      29,    29,   419,   144,   144,   165,   320,   -24,   329,  -832,
    -832,  -832,  -832,  -832,  -832,  -832,    14,    14,   198,   198,
     198,  -832,  -832,  -832,  -832,  -832,   417,   203,  -832,    32,
    -832,   333,   136,   136,   181,   181,   334,    32,   197,    32,
     197,    32,    32,    32,    32,    32,    32,    32,    32,    32,
      32,    32,    32,   336,   203,   203,  -832,   203,   203,   197,
      32,  -832,   197,   197,   339,   340,   465,  -832,   386,    32,
      32,  -832,   203,   458,  -832,  -832,   396,   349,   349,   430,
    -832,    81,  -832,   445,   186,   451,  -832,  -832,   455,   454,
    -832,   350,   144,   144,  -832,   456,    32,   203,   203,   203,
     203,    32,  -832,   203,   459,    32,  -832,  -832,  -832,  -832,
    -832,   460,   195,  -832,   144,  -832,    32,   683,   683,   683,
     136,   136,   683,  -832,  -832,    32,   197,    32,    32,    32,
      32,    32,  -832,  -832,    32,  -832,    32,    32,    32,   136,
     203,   203,   203,   203,    32,   203,   203,   203,  -832,  -832,
    -832,  -832,  -832,  -832,  -832,  -832,   367,   136,   197,   197,
     928,   203,     8,   494,  -832,  -832,  -832,  -832,   172,  -832,
     385,  -832,   144,  -832,  -832,   463,   457,  -832,   203,  -832,
     203,   203,   203,    32,   203,  -832,   462,  -832,  -832,    32,
     203,   683,   683,   683,   683,   203,  -832,  -832,    32,    32,
    -832,  -832,  -832,  -832,  -832,    32,  -832,   203,  -832,  -832,
     203,   203,   203,   203,   203,   203,    32,   203,   197,  -832,
    -832,   203,  -832,  -832,  -832,  -832,   471,   349,  -832,  -832,
    -832,   472,  -832,   144,  -832,  -832,  -832,   203,    32,   203,
    -832,    32,   203,   203,   203,   683,   683,   203,  -832,    32,
    -832,   203,   203,   203,   203,  -832,   203,   203,   197,  -832,
     203,   203,    23,  -832,  -832,   473,  -832,   203,  -832,    32,
    -832,   203,   203,   203,   203,  -832,  -832,  -832,  -832,   203,
    -832,   203,   203,   197,   203,  -832,  -832,  -832,   466,  -832,
    -832,    32,   203,   203,   203,   203,  -832,  -832,   203,   203,
    -832,   203,   144,   428,  -832,  -832,   203,   203,   203,  -832,
     474,    32,  -832,  -832,   203,   203,  -832,   435,  -832,    32,
     203,  -832
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       8,     7,     0,     9,     0,     1,     6,     0,     8,     3,
       0,   221,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,    24,   119,     0,   233,     0,   219,     0,
       0,   152,   153,   154,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,     0,   214,   216,   218,
     213,     0,     0,     0,     0,     0,     8,     5,    20,     0,
      11,    12,    10,    36,    31,    32,    33,    34,    35,    14,
      13,    15,    17,    16,    18,    19,    74,    76,    77,    78,
      79,    80,    81,    82,    83,   104,   101,   102,   103,   100,
      99,    84,    85,    87,    88,    90,    89,    91,    93,    94,
      96,    95,   109,   110,   111,   112,   113,   114,   115,    98,
      97,    86,    75,    92,   105,   106,   107,   116,   117,   108,
     118,     0,    30,     0,    26,    27,    57,    37,    29,    49,
      49,    28,    55,     0,   224,     0,     0,     0,   234,     0,
       0,   220,     0,     0,     0,     0,   302,     0,     0,     0,
     310,   309,   311,     0,   308,     0,     0,     0,     0,     0,
       0,   201,   202,   230,   229,   231,   232,     0,     0,     0,
       0,   283,   286,   345,   346,     0,   350,     0,   212,   246,
     255,   247,   279,   281,     0,     0,   344,   215,   217,     0,
       0,   205,   206,     0,   221,     2,    23,   221,     0,     0,
       0,     0,     0,     0,   227,   227,   227,   227,   227,   227,
     227,   227,   227,   227,   227,   227,   227,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   227,   169,   169,   169,   177,     0,     0,     0,     0,
       0,     0,     0,    72,    46,    56,     0,    72,   225,   299,
     307,     0,     0,     0,   235,   267,     0,     0,     0,     0,
       0,   243,   245,   244,     0,     0,     0,     0,   304,   219,
       0,     0,     0,     0,     0,     0,     0,   260,     0,     0,
       0,   200,   237,   238,     0,     0,     0,     0,     0,   236,
       0,     0,     0,   345,   346,     0,   312,   314,   316,   318,
     320,   323,   328,   329,   333,   336,   340,   346,   280,   282,
     341,   342,   343,   287,   284,   288,   285,   278,     0,   348,
       0,     0,   355,   356,   277,     0,     0,     0,     4,    25,
       8,    21,     0,     0,     0,     0,     0,     0,   228,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   190,     0,     0,     0,
     157,   157,     0,   196,     0,     0,     0,   170,   163,     0,
       0,   178,     0,     0,     0,     0,     0,     0,     0,    50,
       0,    72,    48,    45,    53,    54,    51,    52,   226,     0,
     305,     0,     0,   253,     0,   251,   254,   271,   252,   274,
       0,     0,     0,     0,   299,     0,     0,     0,   185,     0,
     293,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   262,     0,     0,     0,     0,   269,
       0,   192,   141,     0,   142,   140,     0,     0,   134,   347,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   275,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   195,     0,     0,
       0,   164,   165,     0,     0,     0,     0,     0,    72,    72,
      42,    42,     0,    47,   222,     0,   273,   133,   248,   250,
     249,     0,     0,     0,     0,     0,   297,     0,     0,     0,
       0,   328,   352,   353,   354,   289,   351,     0,     0,   147,
       0,     0,     0,   303,   309,     0,     0,   308,     0,     0,
       0,   261,   182,     0,   263,     0,     0,     0,   270,   268,
     192,   192,     0,     0,     0,     0,   315,     0,   317,   319,
     321,   322,   324,   325,   326,   327,   334,   335,   330,   331,
     332,   338,   339,   337,   349,   276,     0,     0,   172,     0,
      22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,     0,     0,     0,
       0,   158,     0,     0,     0,     0,     0,   166,     0,     0,
       0,   173,     0,    58,    40,    39,     0,    72,    72,    69,
      71,     0,   306,     0,     0,     0,   144,   143,     0,     0,
     290,     0,     0,   295,   184,     0,     0,     0,     0,     0,
       0,     0,   256,     0,     0,     0,   183,   291,   193,   194,
     197,     0,     0,   259,     0,   171,     0,     0,     0,     0,
       0,     0,     0,   124,   125,     0,     0,     0,     0,     0,
       0,     0,   132,   126,     0,   128,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   199,   198,
     138,   239,   241,   240,   242,   139,   299,     0,     0,     0,
     176,     0,     0,    64,    59,    43,    41,    44,     0,    73,
       0,   272,     0,   296,   300,     0,     0,   298,     0,   146,
       0,     0,     0,     0,     0,   264,     0,   258,   313,     0,
       0,     0,     0,     0,     0,     0,   120,   121,     0,     0,
     135,   136,   137,   127,   129,     0,   131,     0,   188,   189,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,     0,    63,    60,    61,    62,     0,    72,    68,    67,
      70,     0,   294,     0,   145,   148,   161,     0,     0,     0,
     257,     0,     0,     0,     0,     0,     0,     0,   122,     0,
     130,     0,     0,     0,     0,   150,     0,     0,     0,   265,
       0,     0,     0,    38,   301,     0,   160,     0,   181,     0,
     204,     0,     0,     0,     0,   203,   123,   186,   187,     0,
     151,     0,     0,     0,   167,   265,   179,    66,     0,   292,
     159,     0,     0,     0,     0,     0,   149,   155,     0,     0,
     266,   168,     0,     0,   210,   209,     0,     0,     0,   265,
       0,     0,   208,   207,     0,   162,    65,     0,   156,     0,
       0,   180
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -832,  -832,  -832,   331,   -53,    -2,   337,  -832,  -832,    60,
     -14,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,
      16,  -832,  -832,  -832,   399,    11,  -832,  -832,  -832,  -832,
    -832,  -832,  -197,  -832,  -243,  -832,  -832,  -832,  -832,  -832,
    -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,
    -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,
    -832,  -832,   179,  -832,  -832,  -832,  -832,  -832,  -832,  -832,
      38,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,  -832,
    -832,  -832,  -285,  -832,  -832,  -832,  -832,  -832,  -832,  -832,
    -832,   272,  -832,  -832,  -832,   581,   -45,  -832,  -832,  -832,
       7,  -832,  -832,   805,  -627,  -832,  -832,  -832,   -36,  -832,
    -832,   263,  -832,   483,  -832,  -832,  -831,  -832,   383,  -832,
    -387,  -832,   -81,  -832,   -27,   381,   382,  -832,  -269,  -301,
     145,   -71,  -130,  -148,  -832,   418,  -832,  -168,  1490,   162,
     -37,   117,  -224,  -120,   116,   118,   114,   119,  -150,  -401,
    -832,  -185,  -141,  1218,  -832,  -412,   374
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     8,    56,     3,     4,    57,    58,    59,   331,
     126,    60,    61,     9,    62,    63,    64,    65,    66,    67,
     637,    68,    69,    70,   243,   247,    71,    72,    73,   723,
     724,   787,   640,   641,   382,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,   540,    93,    94,    95,    96,    97,
      98,    99,   495,   100,   101,   102,   502,   628,   103,   104,
     368,   105,   106,   720,   107,   372,   108,   109,   110,   111,
     112,   490,   562,   113,   114,   115,   116,   117,   118,   119,
     120,   142,   121,   135,   389,   339,   259,   139,   253,   287,
     281,   710,   711,   260,   178,   517,   393,   394,   261,   149,
     156,   432,   288,   860,   277,   424,   844,   254,   282,   283,
     396,   397,   398,   180,   262,   182,   183,   263,   429,   410,
     411,   264,   321,   248,   405,   399,   271,   145,   137,   251,
     184,   154,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   185,   186,   535,   536
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     153,   177,   128,   194,   387,   131,    11,   519,   531,   782,
     179,   783,   291,   267,   861,   428,   558,     1,   379,   181,
     461,   385,   386,   167,   847,   318,   557,   553,     5,   258,
     526,   333,   334,   335,   336,   292,   674,   527,   875,     6,
     169,   170,   413,   440,   322,   572,   573,   574,   575,   323,
     750,   751,   752,   319,   195,   755,    10,   197,   150,   151,
     152,   167,   150,   151,   152,   167,   446,   447,     7,   163,
     164,   165,   166,   292,    12,   455,   456,   292,   169,   170,
     457,   122,   169,   170,   258,   167,   284,   560,   127,   784,
     427,   448,   449,   779,   123,   266,   384,   168,   249,   252,
     256,   129,   169,   170,   150,   151,   152,   313,   314,   403,
     561,   427,   274,   150,   151,   152,   437,   650,   124,   280,
     285,   125,   290,   249,   803,   804,   805,   806,   130,   171,
     172,   173,   307,   175,   176,   554,   132,   729,   513,   730,
     320,   322,   250,   532,   533,   534,   323,   444,   445,   450,
     451,   508,   509,   510,   511,   430,   327,   133,   585,   134,
     430,   559,   452,   453,   454,   467,   468,   469,   470,   293,
     294,   175,   176,   293,   294,   175,   176,   523,   833,   834,
     446,   653,   440,   315,   316,   530,   284,   441,   407,   136,
     459,   171,   172,   173,   174,   175,   176,   167,   315,   316,
     317,   163,   164,   165,   166,   448,   449,   380,   177,   292,
     138,   246,   141,   565,   169,   170,   400,   395,   143,   673,
     404,   406,   320,   538,  -345,   167,   313,   314,   412,  -345,
     414,   392,   651,   652,   417,   418,   586,   292,   144,   713,
     645,   146,   169,   170,   538,   150,   151,   152,   147,   747,
     433,   436,   573,   538,   381,   383,   788,   237,   238,   239,
     240,   241,   450,   451,   402,   634,   635,   578,   579,   580,
     278,   369,   370,   148,   430,   668,   669,   194,   150,   151,
     152,   284,   155,   633,   150,   275,   152,   157,   462,   463,
     464,   150,   544,   152,   570,   571,   161,   643,   644,   592,
     593,   594,   595,   648,   649,   293,   294,   175,   176,   576,
     577,   162,   187,   189,   655,   285,   188,   190,   191,   192,
     193,   242,   245,   246,   598,   600,   266,   789,   465,   664,
     268,   791,   270,   293,   294,   175,   176,   272,   273,   671,
     672,   338,   353,   354,   355,   356,   357,   358,   497,   177,
     359,   360,   361,   367,   371,   516,   374,   375,   518,   485,
     388,   376,   377,   378,   390,   391,   380,   520,   401,   409,
     416,   419,   431,   421,   423,   427,   425,   278,   542,   439,
     546,   548,   458,   460,   466,   489,   501,   471,   442,   494,
     499,   278,   825,   278,   726,   727,   507,   278,   443,   514,
     486,   284,   284,   284,   284,   284,   284,   284,   284,   284,
     284,   284,   284,   284,   284,   503,   512,   492,   521,   504,
     522,   506,   528,   250,   538,   543,   680,   681,   736,   284,
     549,   551,   563,   564,   329,   404,   404,   285,   285,   285,
     285,   285,   285,   285,   285,   285,   285,   285,   285,   584,
     684,   613,   686,   591,   618,   596,   620,   616,   621,   624,
     625,   870,   627,   285,   636,   632,   639,   642,   631,   645,
     662,   667,   665,   670,   722,   717,   652,   725,   715,   597,
     599,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   728,   677,   682,   731,   699,   785,   732,
     708,   709,   163,   164,   165,   166,   733,   626,   734,   786,
     737,   735,   792,   745,   747,   793,   800,   258,   167,   822,
     871,   824,   849,   876,   862,   590,   879,   638,   330,   244,
     168,   328,   392,   790,   547,   169,   170,   278,   757,   278,
     496,   415,   289,   278,   823,   714,   150,   151,   152,   308,
     309,   435,   529,   515,   748,   255,   568,   567,   566,   324,
       0,   249,   569,   249,     0,   163,   164,   165,   166,     0,
       0,     0,   163,   164,   165,   166,     0,     0,     0,   278,
     278,   167,   704,     0,     0,   706,   707,   258,   167,   716,
       0,     0,     0,   168,     0,   392,     0,     0,   169,   170,
     168,     0,     0,     0,     0,   169,   170,     0,     0,   150,
     151,   152,     0,     0,     0,     0,   150,   151,   152,     0,
       0,     0,     0,     0,   171,   172,   173,   174,   175,   176,
       0,     0,   177,   177,   177,     0,   276,   177,     0,     0,
       0,   179,   179,   179,     0,     0,   179,     0,     0,   249,
     181,   181,   181,     0,   278,   181,     0,     0,     0,     0,
       0,     0,   278,   278,     0,     0,     0,   278,     0,     0,
       0,     0,     0,   278,     0,   177,     0,     0,     0,     0,
       0,   777,   778,     0,   179,     0,     0,   171,   172,   173,
     174,   175,   176,   181,   171,   172,   539,   174,   175,   176,
       0,     0,     0,     0,   278,     0,   177,   177,   177,   177,
       0,     0,     0,     0,     0,   179,   179,   179,   179,     0,
     163,   164,   165,   166,   181,   181,   181,   181,     0,     0,
       0,   278,   278,     0,   278,   278,   167,     0,     0,     0,
       0,   820,     0,   408,     0,     0,     0,     0,   168,   278,
       0,     0,     0,   169,   170,     0,     0,   420,     0,   422,
     177,   177,     0,   426,   150,   151,   152,     0,     0,   179,
     179,     0,     0,     0,   278,   278,   278,   278,   181,   181,
     278,   843,     0,     0,     0,   848,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,     0,     0,
       0,     0,     0,     0,     0,     0,   859,     0,     0,     0,
       0,     0,   366,     0,     0,     0,     0,   278,   278,   278,
     278,     0,   278,   278,   278,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   547,   278,     0,
       0,     0,   171,   172,   173,   174,   175,   176,     0,     0,
       0,     0,     0,     0,     0,   278,     0,   278,   278,   278,
       0,   278,     0,     0,     0,     0,     0,   278,     0,     0,
       0,     0,   278,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   278,     0,     0,   278,   278,   278,
     278,   278,   278,     0,   278,     0,     0,     0,   278,     0,
     545,     0,     0,   550,     0,   552,     0,     0,     0,   556,
       0,     0,     0,     0,   278,     0,   278,     0,     0,   278,
     278,   278,     0,     0,   278,     0,     0,     0,   278,   278,
     278,   278,     0,   278,   278,     0,     0,   278,   278,     0,
       0,     0,     0,     0,   278,   587,   588,     0,   278,   278,
     278,   278,     0,     0,     0,     0,   278,     0,   278,   278,
     279,   278,     0,   286,     0,   163,   164,   165,   166,   278,
     278,   278,   278,     0,     0,   278,   278,     0,   278,     0,
       0,   167,     0,   278,   278,   278,     0,     0,     0,     0,
       0,   278,   278,   168,     0,     0,     0,   278,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   150,
     544,   152,     0,     0,     0,     0,     0,     0,     0,     0,
     654,     0,     0,     0,     0,     0,     0,     0,   659,   660,
       0,     0,     0,   663,     0,     0,     0,     0,     0,   666,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     675,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   171,   172,   173,
     174,   175,   176,   434,     0,     0,   438,   700,   701,     0,
     702,   703,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   721,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     739,   740,   741,   742,     0,     0,   744,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   498,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   768,   769,   770,   771,     0,   773,   774,
     775,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   780,   781,     0,     0,   524,   525,     0,
       0,     0,     0,     0,     0,     0,     0,   537,     0,   541,
       0,   794,     0,   795,   796,   797,     0,   799,     0,     0,
     555,     0,     0,   802,     0,     0,     0,     0,   807,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     811,     0,     0,   812,   813,   814,   815,   816,   817,     0,
     819,     0,     0,     0,   821,     0,     0,     0,     0,   589,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     826,     0,   828,     0,     0,   830,   831,   832,     0,     0,
     835,     0,   614,   615,   837,   838,   839,   840,     0,   841,
     842,     0,     0,   845,   846,     0,     0,     0,     0,     0,
     850,     0,     0,     0,   852,   853,   854,   855,     0,     0,
       0,     0,   856,     0,   857,   858,     0,     0,     0,   646,
     647,     0,     0,     0,     0,   864,   865,   866,   867,     0,
       0,   868,   869,     0,     0,   656,   657,   658,     0,   872,
     873,   874,     0,   661,     0,     0,     0,   878,     0,     0,
       0,     0,     0,   881,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   306,   310,   311,   312,     0,
       0,     0,     0,     0,   676,     0,     0,     0,     0,     0,
       0,     0,   683,     0,   685,     0,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,     0,     0,
       0,     0,     0,     0,     0,   705,     0,     0,     0,     0,
       0,   712,     0,     0,   718,   719,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     306,   738,     0,   306,   306,     0,   743,     0,     0,     0,
     746,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   749,     0,     0,   306,     0,     0,     0,     0,     0,
     756,     0,   758,   759,   760,   761,   762,     0,     0,   763,
       0,   764,   765,   766,     0,     0,     0,     0,     0,   772,
     310,     0,     0,     0,     0,     0,     0,   140,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     158,   159,   160,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   798,     0,
       0,     0,     0,     0,   801,     0,     0,     0,     0,     0,
       0,     0,     0,   808,   809,     0,     0,     0,     0,     0,
     810,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   818,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   306,   306,   306,   306,     0,     0,     0,
       0,     0,     0,   827,     0,     0,   829,     0,     0,     0,
       0,     0,     0,     0,   836,     0,     0,     0,     0,   306,
       0,     0,     0,     0,     0,     0,     0,   306,     0,   257,
       0,     0,   265,     0,   851,   269,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   306,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   306,   863,     0,   306,   306,
     306,   306,   306,   306,   306,   306,   306,   306,   306,   306,
     306,   306,   306,   581,   582,   583,   877,     0,   306,   325,
     326,     0,     0,     0,   880,     0,     0,     0,   332,     0,
       0,     0,     0,   337,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   352,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   362,   363,   364,
     365,     0,     0,     0,     0,   306,   373,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   306,
     306,     0,     0,     0,     0,   306,   306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   306,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   306,   306,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,     0,   487,   488,     0,   491,     0,   493,
       0,     0,     0,     0,     0,     0,   500,     0,     0,     0,
       0,     0,   505,     0,     0,     0,     0,     0,     0,     0,
     306,   306,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   306,     0,     0,     0,     0,     0,    -9,     0,
       0,     0,     0,    13,    14,    15,    16,    17,    18,    19,
      20,    21,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     306,     0,     0,     0,     0,     0,   306,     0,     0,     0,
     306,    22,     0,    23,    -9,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    24,     0,
     617,     0,   619,     6,     0,   622,   623,     0,     0,     0,
       0,     0,    25,   629,   630,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    26,    27,     0,
       0,   306,     0,    28,    29,    30,     0,     0,     0,    31,
      32,    33,     0,     0,    34,    35,    36,    37,    38,     0,
       0,     0,     0,    39,    40,    41,    42,     0,    43,    44,
      45,    46,    47,    48,    49,    50,     0,     0,     0,    51,
      52,     0,     0,    53,    54,    55,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     306,     0,   678,   679,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     196,     0,     0,     0,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    -8,
      -8,    -8,    -8,    -8,    -8,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     753,   754,    -8,     0,    -8,    -8,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   767,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    -8,
       0,     0,     0,     0,     1,     0,     0,   776,     0,     0,
       0,     0,     0,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    13,    14,    15,
      16,    17,    18,    19,    20,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    22,     0,    23,   329,     0,
       0,     0,     0,     0,     0,     0,    13,    14,    15,    16,
      17,    18,    19,    20,    21,     0,     0,     0,     0,     0,
       0,     0,    24,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    25,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    26,    27,     0,    22,     0,    23,    28,    29,    30,
       0,     0,     0,    31,    32,    33,     0,     0,    34,    35,
      36,    37,    38,     0,     0,     0,     0,    39,    40,    41,
      42,    24,    43,    44,    45,    46,    47,    48,    49,    50,
       0,     0,     0,    51,    52,    25,     0,    53,    54,    55,
     198,   199,   200,   201,   202,   203,     0,     0,     0,     0,
      26,    27,     0,     0,     0,     0,    28,    29,    30,     0,
       0,     0,    31,    32,    33,     0,     0,    34,    35,    36,
      37,    38,     0,     0,     0,     0,    39,    40,    41,    42,
       0,    43,    44,    45,    46,    47,    48,    49,    50,     0,
       0,     0,    51,    52,     0,     0,    53,    54,    55,     0,
       0,     0,     0,     0,     0,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,     0,
       0,   218,   219,   220,   221,     0,     0,     0,   222,   223,
     224,     0,     0,     0,   225,   226,     0,     0,     0,     0,
       0,   227,   228,   229,   230,     0,     0,     0,     0,   231,
       0,     0,     0,     0,     0,     0,     0,     0,   232,   233,
     234,     0,     0,   235,   236
};

static const yytype_int16 yycheck[] =
{
      37,    46,    16,    56,   247,    19,     8,   394,   409,     1,
      46,     3,   160,   143,   845,   284,   428,    85,   242,    46,
     321,   245,   246,    53,     1,    53,   427,    53,     0,    52,
      51,   199,   200,   201,   202,    65,    60,    58,   869,    85,
      70,    71,   266,    67,    41,   446,   447,   448,   449,    46,
     677,   678,   679,    81,    56,   682,   161,    59,    81,    82,
      83,    53,    81,    82,    83,    53,    48,    49,    14,    37,
      38,    39,    40,    65,    57,    61,    62,    65,    70,    71,
      66,   161,    70,    71,    52,    53,   157,    58,    84,    81,
      48,    73,    74,   720,    81,    53,    84,    65,   135,   136,
     137,    81,    70,    71,    81,    82,    83,    43,    44,   257,
      81,    48,   149,    81,    82,    83,    53,   529,    81,   156,
     157,    84,   159,   160,   751,   752,   753,   754,    81,   159,
     160,   161,   162,   163,   164,   161,    81,    56,   381,    58,
     177,    41,   161,    43,    44,    45,    46,    75,    76,    64,
      65,   375,   376,   377,   378,   285,   193,    81,   459,    71,
     290,   430,    77,    78,    79,   333,   334,   335,   336,   161,
     162,   163,   164,   161,   162,   163,   164,   401,   805,   806,
      48,    49,    67,    43,    44,   409,   257,    72,   259,    53,
     320,   159,   160,   161,   162,   163,   164,    53,    43,    44,
      45,    37,    38,    39,    40,    73,    74,    17,   253,    65,
      47,    21,    88,   437,    70,    71,   253,   253,    87,    54,
     257,   258,   259,    58,    41,    53,    43,    44,   265,    46,
     267,    67,    58,    59,   271,   272,   460,    65,    57,   626,
      54,    89,    70,    71,    58,    81,    82,    83,    89,    54,
     287,   288,   653,    58,   243,   244,    84,    22,    23,    24,
      25,    26,    64,    65,   257,   508,   509,   452,   453,   454,
     153,   233,   234,    53,   404,   560,   561,   330,    81,    82,
      83,   352,    53,   507,    81,    82,    83,    81,   325,   326,
     327,    81,    82,    83,   444,   445,    84,   521,   522,   467,
     468,   469,   470,   527,   528,   161,   162,   163,   164,   450,
     451,   161,    93,    89,   538,   352,    93,    89,    81,    81,
      89,    18,    63,    21,   472,   473,    53,   728,   330,   553,
     161,   732,    53,   161,   162,   163,   164,    90,   161,   563,
     564,    36,    57,    89,    89,     4,    89,    57,   362,   394,
      89,     4,     4,    29,    86,   392,    42,    19,   394,   352,
     158,    19,    19,    19,    54,    58,    17,   394,    53,    48,
     161,    58,    53,    57,    57,    48,    58,   260,   415,    54,
     417,   418,    81,    48,   162,    57,    27,   162,    68,    57,
      81,   274,   793,   276,   637,   638,    19,   280,    69,    54,
     161,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,    89,    55,   161,    50,    89,
      53,   161,    53,   161,    58,    54,   594,   595,   652,   500,
     161,   161,    53,    53,    56,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,    54,
     598,    57,   600,   161,   491,   161,   493,   161,   161,   161,
     161,   862,    28,   500,    20,   161,    81,    54,   505,    54,
      54,    49,    58,    54,    16,    89,    59,    81,   626,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,    63,   161,   161,    51,   161,   722,    48,
     161,   161,    37,    38,    39,    40,    51,   500,    54,    15,
      54,   161,    49,    54,    54,    58,    54,    52,    53,    48,
      92,    49,    49,    49,    58,   465,    91,   511,   197,   130,
      65,   194,    67,   730,   417,    70,    71,   420,   686,   422,
     361,   269,   159,   426,   787,   626,    81,    82,    83,   168,
     168,   288,   407,   391,   674,   137,   442,   441,   440,   185,
      -1,   598,   443,   600,    -1,    37,    38,    39,    40,    -1,
      -1,    -1,    37,    38,    39,    40,    -1,    -1,    -1,   462,
     463,    53,   619,    -1,    -1,   622,   623,    52,    53,   626,
      -1,    -1,    -1,    65,    -1,    67,    -1,    -1,    70,    71,
      65,    -1,    -1,    -1,    -1,    70,    71,    -1,    -1,    81,
      82,    83,    -1,    -1,    -1,    -1,    81,    82,    83,    -1,
      -1,    -1,    -1,    -1,   159,   160,   161,   162,   163,   164,
      -1,    -1,   677,   678,   679,    -1,   153,   682,    -1,    -1,
      -1,   677,   678,   679,    -1,    -1,   682,    -1,    -1,   686,
     677,   678,   679,    -1,   537,   682,    -1,    -1,    -1,    -1,
      -1,    -1,   545,   546,    -1,    -1,    -1,   550,    -1,    -1,
      -1,    -1,    -1,   556,    -1,   720,    -1,    -1,    -1,    -1,
      -1,   718,   719,    -1,   720,    -1,    -1,   159,   160,   161,
     162,   163,   164,   720,   159,   160,   161,   162,   163,   164,
      -1,    -1,    -1,    -1,   587,    -1,   751,   752,   753,   754,
      -1,    -1,    -1,    -1,    -1,   751,   752,   753,   754,    -1,
      37,    38,    39,    40,   751,   752,   753,   754,    -1,    -1,
      -1,   614,   615,    -1,   617,   618,    53,    -1,    -1,    -1,
      -1,   778,    -1,   260,    -1,    -1,    -1,    -1,    65,   632,
      -1,    -1,    -1,    70,    71,    -1,    -1,   274,    -1,   276,
     805,   806,    -1,   280,    81,    82,    83,    -1,    -1,   805,
     806,    -1,    -1,    -1,   657,   658,   659,   660,   805,   806,
     663,   818,    -1,    -1,    -1,   822,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   843,    -1,    -1,    -1,
      -1,    -1,   231,    -1,    -1,    -1,    -1,   700,   701,   702,
     703,    -1,   705,   706,   707,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   720,   721,    -1,
      -1,    -1,   159,   160,   161,   162,   163,   164,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   738,    -1,   740,   741,   742,
      -1,   744,    -1,    -1,    -1,    -1,    -1,   750,    -1,    -1,
      -1,    -1,   755,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   767,    -1,    -1,   770,   771,   772,
     773,   774,   775,    -1,   777,    -1,    -1,    -1,   781,    -1,
     417,    -1,    -1,   420,    -1,   422,    -1,    -1,    -1,   426,
      -1,    -1,    -1,    -1,   797,    -1,   799,    -1,    -1,   802,
     803,   804,    -1,    -1,   807,    -1,    -1,    -1,   811,   812,
     813,   814,    -1,   816,   817,    -1,    -1,   820,   821,    -1,
      -1,    -1,    -1,    -1,   827,   462,   463,    -1,   831,   832,
     833,   834,    -1,    -1,    -1,    -1,   839,    -1,   841,   842,
     155,   844,    -1,   158,    -1,    37,    38,    39,    40,   852,
     853,   854,   855,    -1,    -1,   858,   859,    -1,   861,    -1,
      -1,    53,    -1,   866,   867,   868,    -1,    -1,    -1,    -1,
      -1,   874,   875,    65,    -1,    -1,    -1,   880,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     537,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   545,   546,
      -1,    -1,    -1,   550,    -1,    -1,    -1,    -1,    -1,   556,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     587,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,   160,   161,
     162,   163,   164,   288,    -1,    -1,   291,   614,   615,    -1,
     617,   618,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   632,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     657,   658,   659,   660,    -1,    -1,   663,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   364,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   700,   701,   702,   703,    -1,   705,   706,
     707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   720,   721,    -1,    -1,   402,   403,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   412,    -1,   414,
      -1,   738,    -1,   740,   741,   742,    -1,   744,    -1,    -1,
     425,    -1,    -1,   750,    -1,    -1,    -1,    -1,   755,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     767,    -1,    -1,   770,   771,   772,   773,   774,   775,    -1,
     777,    -1,    -1,    -1,   781,    -1,    -1,    -1,    -1,   464,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     797,    -1,   799,    -1,    -1,   802,   803,   804,    -1,    -1,
     807,    -1,   487,   488,   811,   812,   813,   814,    -1,   816,
     817,    -1,    -1,   820,   821,    -1,    -1,    -1,    -1,    -1,
     827,    -1,    -1,    -1,   831,   832,   833,   834,    -1,    -1,
      -1,    -1,   839,    -1,   841,   842,    -1,    -1,    -1,   524,
     525,    -1,    -1,    -1,    -1,   852,   853,   854,   855,    -1,
      -1,   858,   859,    -1,    -1,   540,   541,   542,    -1,   866,
     867,   868,    -1,   548,    -1,    -1,    -1,   874,    -1,    -1,
      -1,    -1,    -1,   880,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   167,   168,   169,   170,    -1,
      -1,    -1,    -1,    -1,   589,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   597,    -1,   599,    -1,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   620,    -1,    -1,    -1,    -1,
      -1,   626,    -1,    -1,   629,   630,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     242,   656,    -1,   245,   246,    -1,   661,    -1,    -1,    -1,
     665,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   676,    -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,
     685,    -1,   687,   688,   689,   690,   691,    -1,    -1,   694,
      -1,   696,   697,   698,    -1,    -1,    -1,    -1,    -1,   704,
     292,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   743,    -1,
      -1,    -1,    -1,    -1,   749,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   758,   759,    -1,    -1,    -1,    -1,    -1,
     765,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   776,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   375,   376,   377,   378,    -1,    -1,    -1,
      -1,    -1,    -1,   798,    -1,    -1,   801,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   809,    -1,    -1,    -1,    -1,   401,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   409,    -1,   139,
      -1,    -1,   142,    -1,   829,   145,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   427,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,   851,    -1,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   871,    -1,   460,   189,
     190,    -1,    -1,    -1,   879,    -1,    -1,    -1,   198,    -1,
      -1,    -1,    -1,   203,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   217,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,   228,   229,
     230,    -1,    -1,    -1,    -1,   507,   236,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   521,
     522,    -1,    -1,    -1,    -1,   527,   528,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   538,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   553,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   563,   564,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,    -1,    -1,   354,   355,    -1,   357,    -1,   359,
      -1,    -1,    -1,    -1,    -1,    -1,   366,    -1,    -1,    -1,
      -1,    -1,   372,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     652,   653,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   674,    -1,    -1,    -1,    -1,    -1,     0,    -1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     722,    -1,    -1,    -1,    -1,    -1,   728,    -1,    -1,    -1,
     732,    53,    -1,    55,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,
     490,    -1,   492,    85,    -1,   495,   496,    -1,    -1,    -1,
      -1,    -1,    94,   503,   504,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,
      -1,   793,    -1,   115,   116,   117,    -1,    -1,    -1,   121,
     122,   123,    -1,    -1,   126,   127,   128,   129,   130,    -1,
      -1,    -1,    -1,   135,   136,   137,   138,    -1,   140,   141,
     142,   143,   144,   145,   146,   147,    -1,    -1,    -1,   151,
     152,    -1,    -1,   155,   156,   157,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     862,    -1,   592,   593,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     680,   681,    53,    -1,    55,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   699,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    -1,    85,    -1,    -1,   717,    -1,    -1,
      -1,    -1,    -1,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    53,    -1,    55,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,    -1,    53,    -1,    55,   115,   116,   117,
      -1,    -1,    -1,   121,   122,   123,    -1,    -1,   126,   127,
     128,   129,   130,    -1,    -1,    -1,    -1,   135,   136,   137,
     138,    80,   140,   141,   142,   143,   144,   145,   146,   147,
      -1,    -1,    -1,   151,   152,    94,    -1,   155,   156,   157,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,
     109,   110,    -1,    -1,    -1,    -1,   115,   116,   117,    -1,
      -1,    -1,   121,   122,   123,    -1,    -1,   126,   127,   128,
     129,   130,    -1,    -1,    -1,    -1,   135,   136,   137,   138,
      -1,   140,   141,   142,   143,   144,   145,   146,   147,    -1,
      -1,    -1,   151,   152,    -1,    -1,   155,   156,   157,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
      -1,   111,   112,   113,   114,    -1,    -1,    -1,   118,   119,
     120,    -1,    -1,    -1,   124,   125,    -1,    -1,    -1,    -1,
      -1,   131,   132,   133,   134,    -1,    -1,    -1,    -1,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,
     150,    -1,    -1,   153,   154
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    85,   166,   169,   170,     0,    85,    14,   167,   178,
     161,   170,    57,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    53,    55,    80,    94,   109,   110,   115,   116,
     117,   121,   122,   123,   126,   127,   128,   129,   130,   135,
     136,   137,   138,   140,   141,   142,   143,   144,   145,   146,
     147,   151,   152,   155,   156,   157,   168,   171,   172,   173,
     176,   177,   179,   180,   181,   182,   183,   184,   186,   187,
     188,   191,   192,   193,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   220,   221,   222,   223,   224,   225,   226,
     228,   229,   230,   233,   234,   236,   237,   239,   241,   242,
     243,   244,   245,   248,   249,   250,   251,   252,   253,   254,
     255,   257,   161,    81,    81,    84,   175,    84,   175,    81,
      81,   175,    81,    81,    71,   258,    53,   303,    47,   262,
     303,    88,   256,    87,    57,   302,    89,    89,    53,   274,
      81,    82,    83,   305,   306,    53,   275,    81,   303,   303,
     303,    84,   161,    37,    38,    39,    40,    53,    65,    70,
      71,   159,   160,   161,   162,   163,   164,   261,   269,   273,
     288,   289,   290,   291,   305,   318,   319,    93,    93,    89,
      89,    81,    81,    89,   169,   170,     1,   170,    30,    31,
      32,    33,    34,    35,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   111,   112,
     113,   114,   118,   119,   120,   124,   125,   131,   132,   133,
     134,   139,   148,   149,   150,   153,   154,    22,    23,    24,
      25,    26,    18,   189,   189,    63,    21,   190,   298,   305,
     161,   304,   305,   263,   282,   300,   305,   303,    52,   261,
     268,   273,   289,   292,   296,   303,    53,   297,   161,   303,
      53,   301,    90,   161,   305,    82,   278,   279,   306,   268,
     305,   265,   283,   284,   296,   305,   268,   264,   277,   283,
     305,   298,    65,   161,   162,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   162,   290,   291,
     318,   318,   318,    43,    44,    43,    44,    45,    53,    81,
     305,   297,    41,    46,   321,   303,   303,   305,   171,    56,
     168,   174,   303,   302,   302,   302,   302,   303,    36,   260,
     260,   260,   260,   260,   260,   260,   260,   260,   260,   260,
     260,   260,   303,    57,    89,    89,     4,    89,    57,    89,
       4,     4,   303,   303,   303,   303,   260,    29,   235,   235,
     235,    86,   240,   303,    42,    19,    19,    19,    19,   307,
      17,   190,   199,   190,    84,   307,   307,   199,   158,   259,
      54,    58,    67,   271,   272,   273,   285,   286,   287,   300,
     305,    53,   265,   298,   305,   299,   305,   296,   278,    48,
     294,   295,   305,   307,   305,   256,   161,   305,   305,    58,
     278,    57,   278,    57,   280,    58,   278,    48,   293,   293,
     297,    53,   276,   305,   268,   276,   305,    53,   268,    54,
      67,    72,    68,    69,    75,    76,    48,    49,    73,    74,
      64,    65,    77,    78,    79,    61,    62,    66,    81,   297,
      48,   294,   305,   305,   305,   170,   162,   302,   302,   302,
     302,   162,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   265,   161,   303,   303,    57,
     246,   303,   161,   303,    57,   227,   227,   175,   268,    81,
     303,    27,   231,    89,    89,   303,   161,    19,   307,   307,
     307,   307,    55,   199,    54,   304,   305,   270,   273,   285,
     289,    50,    53,   307,   268,   268,    51,    58,    53,   295,
     307,   314,    43,    44,    45,   320,   321,   268,    58,   161,
     219,   268,   305,    54,    82,   278,   305,   306,   305,   161,
     278,   161,   278,    53,   161,   268,   278,   314,   320,   293,
      58,    81,   247,    53,    53,   307,   310,   309,   311,   312,
     313,   313,   314,   314,   314,   314,   317,   317,   316,   316,
     316,   318,   318,   318,    54,   294,   307,   278,   278,   268,
     174,   161,   302,   302,   302,   302,   161,   265,   298,   265,
     298,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     265,   265,   265,    57,   268,   268,   161,   303,   305,   303,
     305,   161,   303,   303,   161,   161,   265,    28,   232,   303,
     303,   305,   161,   307,   199,   199,    20,   185,   185,    81,
     197,   198,    54,   307,   307,    54,   268,   268,   307,   307,
     320,    58,    59,    49,   278,   307,   268,   268,   268,   278,
     278,   268,    54,   278,   307,    58,   278,    49,   247,   247,
      54,   307,   307,    54,    60,   278,   268,   161,   303,   303,
     302,   302,   161,   268,   298,   268,   298,   268,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   268,   268,   161,
     278,   278,   278,   278,   305,   268,   305,   305,   161,   161,
     266,   267,   268,   285,   287,   298,   305,    89,   268,   268,
     238,   278,    16,   194,   195,    81,   199,   199,    63,    56,
      58,    51,    48,    51,    54,   161,   307,    54,   268,   278,
     278,   278,   278,   268,   278,    54,   268,    54,   308,   268,
     269,   269,   269,   303,   303,   269,   268,   298,   268,   268,
     268,   268,   268,   268,   268,   268,   268,   303,   278,   278,
     278,   278,   268,   278,   278,   278,   303,   305,   305,   269,
     278,   278,     1,     3,    81,   307,    15,   196,    84,   314,
     197,   314,    49,    58,   278,   278,   278,   278,   268,   278,
      54,   268,   278,   269,   269,   269,   269,   278,   268,   268,
     268,   278,   278,   278,   278,   278,   278,   278,   268,   278,
     305,   278,    48,   199,    49,   314,   278,   268,   278,   268,
     278,   278,   278,   269,   269,   278,   268,   278,   278,   278,
     278,   278,   278,   305,   281,   278,   278,     1,   305,    49,
     278,   268,   278,   278,   278,   278,   278,   278,   278,   305,
     278,   281,    58,   268,   278,   278,   278,   278,   278,   278,
     314,    92,   278,   278,   278,   281,    49,   268,   278,    91,
     268,   278
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   165,   166,   167,   168,   168,   169,   169,   170,   170,
     171,   171,   171,   171,   171,   171,   171,   171,   171,   171,
     171,   172,   172,   172,   173,   174,   175,   175,   176,   177,
     178,   179,   179,   179,   179,   179,   179,   180,   181,   182,
     183,   184,   185,   185,   186,   187,   187,   188,   188,   189,
     189,   190,   191,   192,   192,   192,   192,   193,   194,   194,
     195,   195,   195,   195,   196,   196,   196,   197,   197,   197,
     198,   198,   199,   199,   200,   200,   200,   200,   200,   200,
     200,   200,   200,   200,   200,   200,   200,   200,   200,   200,
     200,   200,   200,   200,   200,   200,   200,   200,   200,   200,
     200,   200,   200,   200,   200,   200,   200,   200,   200,   200,
     200,   200,   200,   200,   200,   200,   200,   200,   200,   201,
     202,   202,   202,   202,   203,   203,   204,   205,   206,   207,
     208,   208,   209,   210,   211,   212,   213,   214,   215,   215,
     216,   216,   216,   217,   217,   218,   218,   219,   220,   221,
     222,   223,   224,   224,   224,   225,   226,   227,   227,   228,
     229,   229,   230,   231,   231,   232,   232,   233,   234,   235,
     235,   236,   237,   238,   238,   238,   239,   240,   240,   241,
     242,   243,   243,   243,   244,   245,   245,   245,   245,   245,
     246,   246,   247,   247,   247,   248,   248,   248,   248,   248,
     248,   249,   250,   251,   251,   252,   253,   254,   254,   254,
     254,   255,   255,   255,   255,   255,   255,   255,   255,   256,
     256,   257,   257,   258,   258,   259,   259,   260,   260,   261,
     261,   261,   261,   262,   262,   263,   264,   265,   265,   266,
     266,   267,   267,   268,   268,   268,   269,   269,   270,   270,
     270,   271,   271,   272,   272,   273,   274,   275,   276,   277,
     278,   278,   279,   280,   280,   281,   281,   282,   283,   283,
     284,   285,   285,   286,   287,   288,   288,   289,   289,   289,
     289,   289,   289,   290,   290,   290,   291,   291,   291,   292,
     292,   293,   294,   295,   295,   295,   296,   296,   297,   298,
     299,   300,   301,   301,   302,   303,   303,   304,   305,   305,
     306,   306,   307,   308,   308,   309,   309,   310,   310,   311,
     311,   312,   312,   312,   313,   313,   313,   313,   313,   314,
     315,   315,   315,   315,   316,   316,   316,   317,   317,   317,
     317,   318,   318,   318,   318,   319,   319,   319,   319,   319,
     319,   320,   320,   320,   320,   321,   321
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     5,     1,     3,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     2,     1,     1,     1,     1,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     2,     9,     6,
       6,     7,     0,     2,     7,     4,     3,     5,     4,     0,
       2,     2,     4,     4,     4,     2,     3,     2,     0,     1,
       2,     2,     2,     2,     0,     6,     3,     3,     3,     1,
       3,     1,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       7,     7,     8,     9,     6,     6,     6,     7,     6,     7,
       8,     7,     6,     5,     4,     7,     7,     7,     6,     6,
       4,     4,     4,     6,     6,     8,     7,     1,     8,    10,
       8,     9,     1,     1,     1,    10,    13,     0,     2,    10,
       9,     8,    12,     0,     1,     0,     1,     9,    10,     0,
       1,     6,     5,     0,     2,     2,     6,     0,     1,     9,
      16,     9,     5,     6,     6,     4,     9,     9,     7,     7,
       0,     2,     0,     2,     2,     4,     3,     6,     6,     6,
       3,     2,     2,     9,     9,     2,     2,    12,    12,    11,
      11,     1,     2,     1,     1,     2,     1,     2,     1,     0,
       1,     0,     5,     0,     1,     0,     1,     0,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     5,     7,     4,     4,
       1,     3,     2,     2,     4,     0,     2,     1,     3,     2,
       3,     1,     4,     2,     1,     3,     4,     2,     2,     1,
       2,     1,     2,     1,     2,     2,     1,     2,     2,     3,
       4,     3,     7,     1,     5,     3,     5,     3,     5,     1,
       4,     7,     0,     3,     2,     3,     5,     1,     1,     1,
       1,     1,     1,     5,     1,     3,     1,     3,     1,     3,
       1,     3,     3,     1,     3,     3,     3,     3,     1,     1,
       3,     3,     3,     1,     3,     3,     1,     3,     3,     3,
       1,     2,     2,     2,     1,     1,     1,     3,     2,     4,
       1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pBuilder, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pBuilder);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pBuilder);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, CISA_IR_Builder* pBuilder)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, CISA_IR_Builder* pBuilder)
{
  YY_USE (yyvaluep);
  YY_USE (pBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pBuilder)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Listing: NewlinesOpt ListingHeader NewlinesOpt Statements NewlinesOpt  */
#line 513 "CISA.y"
                                                                      {
        TRACE("\n** Listing Complete\n");
        pBuilder->CISA_post_file_parse();
    }
#line 2742 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 23: /* Scope: ScopeStart error  */
#line 543 "CISA.y"
                       {
        PARSE_ERROR_AT((int)(yyvsp[-1].intval), "unclosed scope");
    }
#line 2750 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 24: /* ScopeStart: LBRACE  */
#line 547 "CISA.y"
           {
        pBuilder->CISA_push_decl_scope();
        (yyval.intval) = CISAlineno;
    }
#line 2759 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 25: /* ScopeEnd: RBRACE  */
#line 551 "CISA.y"
                 {pBuilder->CISA_pop_decl_scope();}
#line 2765 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 28: /* DirectiveKernel: DIRECTIVE_KERNEL IdentOrStringLit  */
#line 562 "CISA.y"
    {
        VISAKernel *cisa_kernel = NULL;
        pBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
    }
#line 2774 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 29: /* DirectiveGlobalFunction: DIRECTIVE_GLOBAL_FUNC IdentOrStringLit  */
#line 570 "CISA.y"
  {
      VISAFunction *cisa_kernel = NULL;
      pBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
  }
#line 2783 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 30: /* DirectiveVersion: DIRECTIVE_VERSION DEC_LIT DOT DEC_LIT  */
#line 578 "CISA.y"
   {
       pBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].intval), (unsigned char)(yyvsp[0].intval));
   }
#line 2791 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 37: /* DeclFunction: DIRECTIVE_FUNCDECL STRING_LIT  */
#line 592 "CISA.y"
    {
        // do nothing as it's informational only
    }
#line 2799 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 38: /* DeclVariable: DIRECTIVE_DECL IDENT V_TYPE_EQ_G DECL_DATA_TYPE NUM_ELTS_EQ IntExp AlignAttrOpt AliasAttrOpt GenAttrOpt  */
#line 599 "CISA.y"
    {
       ABORT_ON_FAIL(pBuilder->CISA_general_variable_decl(
           (yyvsp[-7].string), (unsigned int)(yyvsp[-3].intval), (yyvsp[-5].type), (yyvsp[-2].align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
    }
#line 2809 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 39: /* DeclAddress: DIRECTIVE_DECL IDENT V_TYPE_EQ_A NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 607 "CISA.y"
   {
       ABORT_ON_FAIL(
           pBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), ISA_TYPE_UW, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 2819 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 40: /* DeclPredicate: DIRECTIVE_DECL IDENT V_TYPE_EQ_P NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 615 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 2828 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 41: /* DeclSampler: DIRECTIVE_DECL IDENT V_TYPE_EQ_S NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 622 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), CISAlineno));
   }
#line 2836 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 42: /* VNameEqOpt: %empty  */
#line 625 "CISA.y"
                    {(yyval.string) = "";}
#line 2842 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 43: /* VNameEqOpt: V_NAME_EQ IDENT  */
#line 625 "CISA.y"
                                                 {(yyval.string) = (yyvsp[0].string);}
#line 2848 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 44: /* DeclSurface: DIRECTIVE_DECL IDENT V_TYPE_EQ_T NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 629 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 2857 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 45: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset InputSize  */
#line 637 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 2865 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 46: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset  */
#line 642 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-1].string), (short)(yyvsp[0].intval), (unsigned short)size, CISAlineno));
    }
#line 2876 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 47: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset InputSize GenAttrOpt  */
#line 654 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_implicit_input_directive(
            (yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].intval), (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 2885 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 48: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset GenAttrOpt  */
#line 661 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-2].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)size, CISAlineno));
    }
#line 2896 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 49: /* InputOffset: %empty  */
#line 668 "CISA.y"
                    {(yyval.intval) = 0;}
#line 2902 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 50: /* InputOffset: OFFSET_EQ IntExp  */
#line 668 "CISA.y"
                                                 {(yyval.intval) = (yyvsp[0].intval);}
#line 2908 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 51: /* InputSize: SIZE_EQ IntExp  */
#line 669 "CISA.y"
                          {(yyval.intval) = (yyvsp[0].intval);}
#line 2914 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 52: /* DirectiveParameter: DIRECTIVE_PARAMETER IDENT InputSize GenAttrOpt  */
#line 676 "CISA.y"
                                                   {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), 0, (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 2922 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 53: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS STRING_LIT  */
#line 682 "CISA.y"
                                                  {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno));
    }
#line 2930 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 54: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS IntExp  */
#line 686 "CISA.y"
                                              {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].intval), CISAlineno));
    }
#line 2938 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 55: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT  */
#line 690 "CISA.y"
                                {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[0].string), nullptr, CISAlineno));
    }
#line 2946 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 56: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS  */
#line 694 "CISA.y"
                                       {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno));
    }
#line 2954 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 57: /* DirectiveFunc: DIRECTIVE_FUNC IdentOrStringLit  */
#line 700 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_function_directive((yyvsp[0].string), CISAlineno));
    }
#line 2962 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 58: /* AlignAttrOpt: %empty  */
#line 705 "CISA.y"
                     {(yyval.align) = ALIGN_BYTE;}
#line 2968 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 60: /* Align: ALIGN_EQ ALIGN_KEYWORD  */
#line 707 "CISA.y"
                           { // 2GRF, 32word, ...
        (yyval.align) = (yyvsp[0].align);
    }
#line 2976 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 61: /* Align: ALIGN_EQ IDENT  */
#line 711 "CISA.y"
                   { // e.g. byte, word, dword, qword, GRF, GRFx2
       if (!ParseAlign(pBuilder, (yyvsp[0].string), (yyval.align))) {
           PARSE_ERROR((yyvsp[0].string), ": invalid align value");
       }
    }
#line 2986 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 62: /* Align: ALIGN_EQ IntExp  */
#line 717 "CISA.y"
                    {
        // e.g. %sizeof(GRF) or %sizeof(DECL)
        (yyval.align) = AlignBytesToVisaAlignment((int)(yyvsp[0].intval));
        if ((yyval.align) == ALIGN_UNDEF) {
            PARSE_ERROR("invalid align size (must be 1, 2, 4, 8, ..., 128)");
        }
    }
#line 2998 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 63: /* Align: ALIGN_EQ error  */
#line 725 "CISA.y"
                   {
        PARSE_ERROR("syntax error in align attribute");
    }
#line 3006 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 64: /* AliasAttrOpt: %empty  */
#line 732 "CISA.y"
    {
       (yyval.alias).aliasname = NULL;
       (yyval.alias).offset = 0;
    }
#line 3015 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 65: /* AliasAttrOpt: ALIAS_EQ LANGLE Var COMMA IntExpNRA RANGLE  */
#line 737 "CISA.y"
    {
       (yyval.alias).aliasname = (yyvsp[-3].string);
       (yyval.alias).offset = (int)(yyvsp[-1].intval);
    }
#line 3024 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 66: /* AliasAttrOpt: ALIAS_EQ LANGLE error  */
#line 742 "CISA.y"
    {
       PARSE_ERROR("syntax error in alias attribute");
    }
#line 3032 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 67: /* OneAttr: IDENT EQUALS IntExpNRA  */
#line 748 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), (yyvsp[0].intval), nullptr);
    }
#line 3040 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 68: /* OneAttr: IDENT EQUALS STRING_LIT  */
#line 752 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), 0, (yyvsp[0].string));
    }
#line 3048 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 69: /* OneAttr: IDENT  */
#line 756 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[0].string), 0, nullptr);
    }
#line 3056 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 70: /* AttrOpt: AttrOpt COMMA OneAttr  */
#line 762 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3064 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 71: /* AttrOpt: OneAttr  */
#line 767 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3072 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 72: /* GenAttrOpt: %empty  */
#line 773 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 3080 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 73: /* GenAttrOpt: ATTR_EQ LBRACE AttrOpt RBRACE  */
#line 777 "CISA.y"
    {
        (yyval.intval) = 1;
    }
#line 3088 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 119: /* Label: LABEL  */
#line 833 "CISA.y"
             {pBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);}
#line 3094 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 120: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 838 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3103 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 121: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar PredVar  */
#line 844 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].vISADecl), (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), CISAlineno);
    }
#line 3111 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 122: /* LogicInstruction: Predicate TERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 849 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3120 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 123: /* LogicInstruction: Predicate QUATERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 855 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-8].pred_reg), (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3129 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 124: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 863 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
    }
#line 3138 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 125: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar  */
#line 869 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), NULL, CISAlineno);
    }
#line 3147 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 126: /* MathInstruction_2OPND: Predicate MATH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 876 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3156 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 127: /* MathInstruction_3OPND: Predicate MATH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 883 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3165 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 128: /* ArithInstruction_2OPND: Predicate ARITH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 890 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3174 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 129: /* ArithInstruction_3OPND: Predicate ARITH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 897 "CISA.y"
    {
        MUST_HOLD(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)),
            "wrong type of src0 operand");
        pBuilder->CISA_create_arith_instruction(
            (yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3186 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 130: /* ArithInstruction_4OPND: Predicate ARITH4_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 908 "CISA.y"
     {
         pBuilder->CISA_create_arith_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3195 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 131: /* ArithInstruction_4OPND: Predicate ARITH4_OP2 ExecSize VecDstOperand_G_I VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 915 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3204 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 132: /* AntiTrigInstruction: Predicate ANTI_TRIG_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 925 "CISA.y"
    {
        pBuilder->CISA_create_invtri_inst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3213 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 133: /* AddrAddInstruction: ADDR_ADD_OP ExecSize VecDstOperand_A VecSrcOperand_G_A_AO VecSrcOperand_G_IMM_AO  */
#line 934 "CISA.y"
    {
        // a grammatically problematic instruction
        //   addr_add (M1_NM, 1) A0(0)<1> &V127 - 0x10...
        //                                        ^^^^ next operand or V127 offset
        pBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3225 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 134: /* SetpInstruction: SETP_OP ExecSize PredVar VecSrcOperand_G_I_IMM  */
#line 944 "CISA.y"
    {
        pBuilder->CISA_create_setp_instruction(
            (yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3234 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 135: /* SelInstruction: Predicate SEL_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 951 "CISA.y"
    {
        pBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3243 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 136: /* MinInstruction: Predicate MIN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 958 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3252 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 137: /* MaxInstruction: Predicate MAX_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 966 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(
            1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3262 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 138: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM_A_AO  */
#line 975 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3272 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 139: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I PredVar  */
#line 982 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].vISADecl), CISAlineno));
    }
#line 3280 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 140: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand SrcStateOperand  */
#line 988 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3289 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 141: /* MovsInstruction: MOVS_OP ExecSize VecDstOperand_G SrcStateOperand  */
#line 994 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3298 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 142: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand VecSrcOperand_G_I_IMM  */
#line 1000 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3307 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 143: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1018 "CISA.y"
    {
        pBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3316 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 144: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1025 "CISA.y"
    {
        // NOTE: predication not permitted.  Apparently the vISA API doesn't allow for predicated compares
        pBuilder->CISA_create_cmp_instruction(
            (yyvsp[-4].cond_mod), ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3327 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 145: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var MediaInstructionPlaneID VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1035 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].intval), (yyvsp[-4].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3337 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 146: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1043 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-6].opcode), (yyvsp[-5].media_mode), (yyvsp[-4].offset).row, (yyvsp[-4].offset).elem, (int)0, (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3347 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 147: /* MediaInstructionPlaneID: DEC_LIT  */
#line 1049 "CISA.y"
                                 {
        MUST_HOLD((yyvsp[0].intval) <= 0xF, "PlaneID must less than 0xF");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3356 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 148: /* ScatterInstruction: SCATTER_OP ElemNum ExecSize OwordModifier Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1057 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_instruction(
            (yyvsp[-7].opcode), (int)(yyvsp[-6].intval), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3366 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 149: /* ScatterTypedInstruction: Predicate SCATTER_TYPED_OP SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1066 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_typed_instruction(
            (yyvsp[-8].opcode), (yyvsp[-9].pred_reg), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string),
            (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3376 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 150: /* Scatter4ScaledInstruction: Predicate SCATTER4_SCALED_OP SAMPLER_CHANNEL ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1075 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_scaled_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3386 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 151: /* ScatterScaledInstruction: Predicate SCATTER_SCALED_OP DOT DEC_LIT ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1084 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_scaled_instruction(
            (yyvsp[-7].opcode), (yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].intval), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3396 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 152: /* SynchronizationInstruction: BARRIER_OP  */
#line 1091 "CISA.y"
               {
        pBuilder->CISA_create_sync_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3404 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 153: /* SynchronizationInstruction: SBARRIER_SIGNAL  */
#line 1094 "CISA.y"
                      {
        pBuilder->CISA_create_sbarrier_instruction(true, CISAlineno);
    }
#line 3412 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 154: /* SynchronizationInstruction: SBARRIER_WAIT  */
#line 1097 "CISA.y"
                    {
        pBuilder->CISA_create_sbarrier_instruction(false, CISAlineno);
    }
#line 3420 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 155: /* DwordAtomicInstruction: Predicate DWORD_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand  */
#line 1103 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_dword_atomic_instruction(
            (yyvsp[-9].pred_reg), (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3429 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 156: /* TypedAtomicInstruction: Predicate TYPED_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1110 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_typed_atomic_instruction(
            (yyvsp[-12].pred_reg), (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
            (yyvsp[-6].RawVar), (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3439 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 157: /* Atomic16Opt: %empty  */
#line 1117 "CISA.y"
             {(yyval.flag) = false;}
#line 3445 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 158: /* Atomic16Opt: DOT DEC_LIT  */
#line 1118 "CISA.y"
                  { // .16
        MUST_HOLD(((yyvsp[0].intval) == 16), "only supports 16");
        (yyval.flag) = true;
    }
#line 3454 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 159: /* SampleUnormInstruction: SAMPLE_UNORM_OP SAMPLER_CHANNEL CHANNEL_OUTPUT Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1125 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sampleunorm_instruction(
            (yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string),
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3464 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 160: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var Var RawOperand RawOperand RawOperand RawOperand  */
#line 1134 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
            (yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].intval), (yyvsp[-5].string), (yyvsp[-4].string),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3474 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 161: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var RawOperand RawOperand RawOperand RawOperand  */
#line 1142 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
           (yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].intval), "", (yyvsp[-4].string),
           (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3484 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 162: /* Sample3dInstruction: Predicate SAMPLE_3D_OP PixelNullMaskEnableOpt CPSEnableOpt NonUniformSamplerEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1152 "CISA.y"
   {
       const bool success = pBuilder->create3DSampleInstruction(
           (yyvsp[-11].pred_reg), (yyvsp[-10].sample3DOp), (yyvsp[-9].pixel_null_mask), (yyvsp[-8].cps), (yyvsp[-7].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-6].s_channel)),
           (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3497 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 163: /* CPSEnableOpt: %empty  */
#line 1161 "CISA.y"
                     {(yyval.cps) = false;}
#line 3503 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 164: /* CPSEnableOpt: CPS  */
#line 1161 "CISA.y"
                                          {(yyval.cps) = true;}
#line 3509 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 165: /* NonUniformSamplerEnableOpt: %empty  */
#line 1163 "CISA.y"
                                   {(yyval.non_uniform_sampler) = false;}
#line 3515 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 166: /* NonUniformSamplerEnableOpt: NON_UNIFORM_SAMPLER  */
#line 1163 "CISA.y"
                                                                       {(yyval.non_uniform_sampler) = true;}
#line 3521 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 167: /* Load3dInstruction: Predicate LOAD_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var RawOperand RawOperandArray  */
#line 1169 "CISA.y"
   {
       const bool success = pBuilder->create3DLoadInstruction(
           (yyvsp[-8].pred_reg), (yyvsp[-7].sample3DOp), (yyvsp[-6].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-5].s_channel)),
           (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3534 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 168: /* Gather43dInstruction: Predicate SAMPLE4_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1182 "CISA.y"
   {
       const bool success = pBuilder->createSample4Instruction(
          (yyvsp[-9].pred_reg), (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
          (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
          (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3547 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 169: /* PixelNullMaskEnableOpt: %empty  */
#line 1191 "CISA.y"
                               {(yyval.pixel_null_mask) = false;}
#line 3553 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 170: /* PixelNullMaskEnableOpt: PIXEL_NULL_MASK  */
#line 1191 "CISA.y"
                                                               {(yyval.pixel_null_mask) = true;}
#line 3559 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 171: /* ResInfo3dInstruction: RESINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand  */
#line 1195 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_RESINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3569 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 172: /* SampleInfo3dInstruction: SAMPLEINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand  */
#line 1203 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_SAMPLEINFO, (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-1].string), NULL, (yyvsp[0].RawVar), CISAlineno));
   }
#line 3579 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 173: /* RTWriteOperandParse: %empty  */
#line 1211 "CISA.y"
    {
    }
#line 3586 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 174: /* RTWriteOperandParse: RTWriteOperandParse VecSrcOperand_G_IMM  */
#line 1214 "CISA.y"
    {
        RTRWOperands.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
    }
#line 3594 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 175: /* RTWriteOperandParse: RTWriteOperandParse RawOperand  */
#line 1218 "CISA.y"
    {
        RTRWOperands.push_back((yyvsp[0].RawVar));
    }
#line 3602 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 176: /* RTWriteInstruction: Predicate RTWRITE_OP_3D RTWriteModeOpt ExecSize Var RTWriteOperandParse  */
#line 1223 "CISA.y"
   {
       bool result = pBuilder->CISA_create_rtwrite_3d_instruction(
           (yyvsp[-5].pred_reg), (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
           RTRWOperands, CISAlineno);
       RTRWOperands.clear();
       if (!result)
           YYABORT; // already reported
   }
#line 3615 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 177: /* RTWriteModeOpt: %empty  */
#line 1232 "CISA.y"
                       {(yyval.string) = 0;}
#line 3621 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 179: /* URBWriteInstruction: Predicate URBWRITE_OP_3D ExecSize DEC_LIT DEC_LIT RawOperand RawOperand RawOperand RawOperand  */
#line 1237 "CISA.y"
    {
        pBuilder->CISA_create_urb_write_3d_instruction(
            (yyvsp[-8].pred_reg), (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-4].intval),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3631 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 180: /* AVSInstruction: AVS_OP SAMPLER_CHANNEL Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM CNTRL VecSrcOperand_G_I_IMM EXECMODE VecSrcOperand_G_I_IMM RawOperand  */
#line 1245 "CISA.y"
    {
        pBuilder->CISA_create_avs_instruction(
            ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string),
            (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd,
            (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd,
            (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 3643 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 181: /* VMEInstruction: VME_IME_OP VMEOpndIME Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1257 "CISA.y"
   {
       //     1 - OP
       //     2 - StreamMode, SearchCtrl
       //     3 - Surface
       //     4 - UNIInput
       //     5 - IMEInput
       //     6 - ref0
       //     7 - ref1
       //     8 - CostCenter
       //     9 - Output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_ime_instruction(
            (yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-6].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3661 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 182: /* VMEInstruction: VME_SIC_OP Var RawOperand RawOperand RawOperand  */
#line 1273 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3669 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 183: /* VMEInstruction: VME_FBR_OP VMEOpndFBR Var RawOperand RawOperand RawOperand  */
#line 1279 "CISA.y"
   {
        //    1 - OP
        //    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
        //    3 - surface
        //    4 - UNIInput
        //    5 - FBRInput
        //    6 - output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string),
            (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3684 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 184: /* OwordInstruction: OWORD_OP OwordModifier ExecSize Var VecSrcOperand_G_I_IMM RawOperand  */
#line 1292 "CISA.y"
    {
        ABORT_ON_FAIL(
            pBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3693 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 185: /* SvmInstruction: SVM_OP ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1300 "CISA.y"
    {
        bool aligned = false;
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).exec_size, aligned,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 3703 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 186: /* SvmInstruction: Predicate SVM_SCATTER_OP DOT DEC_LIT DOT DEC_LIT ExecSize RawOperand RawOperand  */
#line 1307 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].pred_reg), (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-3].intval), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3712 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 187: /* SvmInstruction: Predicate SVM_ATOMIC_OP ATOMIC_SUB_OP AtomicBitwidthOpt ExecSize RawOperand RawOperand RawOperand RawOperand  */
#line 1313 "CISA.y"
    {
        pBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (unsigned short)(yyvsp[-5].intval),
            (yyvsp[-3].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), (yyvsp[-2].RawVar), CISAlineno);
    }
#line 3721 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 188: /* SvmInstruction: Predicate SVM_GATHER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1319 "CISA.y"
    {
        pBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3730 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 189: /* SvmInstruction: Predicate SVM_SCATTER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1325 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3739 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 190: /* AtomicBitwidthOpt: %empty  */
#line 1331 "CISA.y"
             {(yyval.intval) = 32;}
#line 3745 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 191: /* AtomicBitwidthOpt: DOT DEC_LIT  */
#line 1332 "CISA.y"
                  {
        MUST_HOLD((yyvsp[0].intval) == 16 || (yyvsp[0].intval) == 32 || (yyvsp[0].intval) == 64, "only supports 16 or 64");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3754 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 192: /* SwitchLabels: %empty  */
#line 1340 "CISA.y"
    {
    }
#line 3761 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 193: /* SwitchLabels: COMMA SwitchLabels  */
#line 1343 "CISA.y"
    {
    }
#line 3768 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 194: /* SwitchLabels: IDENT SwitchLabels  */
#line 1346 "CISA.y"
    {
        // parse rule means we see last label first
        switchLabels.push_front((yyvsp[-1].string));
    }
#line 3777 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 195: /* BranchInstruction: Predicate BRANCH_OP ExecSize IdentOrStringLit  */
#line 1353 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), CISAlineno);
    }
#line 3785 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 196: /* BranchInstruction: Predicate RET_OP ExecSize  */
#line 1357 "CISA.y"
    {
        pBuilder->CISA_Create_Ret((yyvsp[-2].pred_reg), (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
    }
#line 3793 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 197: /* BranchInstruction: SWITCHJMP_OP ExecSize VecSrcOperand_G_I_IMM LPAREN SwitchLabels RPAREN  */
#line 1361 "CISA.y"
    {
        pBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, switchLabels, CISAlineno);
        switchLabels.clear();
    }
#line 3802 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 198: /* BranchInstruction: Predicate FCALL ExecSize IDENT DEC_LIT DEC_LIT  */
#line 1367 "CISA.y"
    {
        pBuilder->CISA_create_fcall_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 3810 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 199: /* BranchInstruction: Predicate IFCALL ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 1372 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-5].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 3820 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 200: /* BranchInstruction: FADDR IDENT VecDstOperand_G_I  */
#line 1379 "CISA.y"
    {
        pBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3828 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 201: /* FILE: FILE_OP STRING_LIT  */
#line 1384 "CISA.y"
    {
        pBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string), CISAlineno);
    }
#line 3836 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 202: /* LOC: LOC_OP DEC_LIT  */
#line 1389 "CISA.y"
    {
        pBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 3844 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 203: /* RawSendInstruction: Predicate RAW_SEND_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 1395 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3853 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 204: /* RawSendInstruction: Predicate RAW_SENDC_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 1402 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3862 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 205: /* LifetimeStartInst: LIFETIME_START_OP IDENT  */
#line 1409 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno));
    }
#line 3870 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 206: /* LifetimeEndInst: LIFETIME_END_OP IDENT  */
#line 1415 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno));
    }
#line 3878 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 207: /* RawSendsInstruction: Predicate RAW_SENDS_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 1421 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3889 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 208: /* RawSendsInstruction: Predicate RAW_SENDS_EOT_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 1429 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3900 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 209: /* RawSendsInstruction: Predicate RAW_SENDSC_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 1437 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3911 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 210: /* RawSendsInstruction: Predicate RAW_SENDSC_EOT_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 1445 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3922 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 211: /* NullaryInstruction: CACHE_FLUSH_OP  */
#line 1454 "CISA.y"
    {
        pBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3930 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 212: /* NullaryInstruction: WAIT_OP VecSrcOperand_G_IMM  */
#line 1459 "CISA.y"
    {
        pBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3938 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 213: /* NullaryInstruction: YIELD_OP  */
#line 1464 "CISA.y"
    {
        pBuilder->CISA_create_yield_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3946 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 214: /* NullaryInstruction: FENCE_GLOBAL_OP  */
#line 1469 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0, CISAlineno);
    }
#line 3954 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 215: /* NullaryInstruction: FENCE_GLOBAL_OP FENCE_OPTIONS  */
#line 1474 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options), CISAlineno);
    }
#line 3962 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 216: /* NullaryInstruction: FENCE_LOCAL_OP  */
#line 1479 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20, CISAlineno);
    }
#line 3970 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 217: /* NullaryInstruction: FENCE_LOCAL_OP FENCE_OPTIONS  */
#line 1484 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20, CISAlineno);
    }
#line 3978 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 218: /* NullaryInstruction: FENCE_SW_OP  */
#line 1489 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80, CISAlineno);
    }
#line 3986 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 219: /* OwordModifier: %empty  */
#line 1493 "CISA.y"
                      {(yyval.oword_mod) = false;}
#line 3992 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 221: /* Predicate: %empty  */
#line 1500 "CISA.y"
    {
        (yyval.pred_reg) = NULL;
    }
#line 4000 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 222: /* Predicate: LPAREN PredSign PredVar PredCtrlOpt RPAREN  */
#line 1505 "CISA.y"
    {
        (yyval.pred_reg) = pBuilder->CISA_create_predicate_operand((yyvsp[-2].vISADecl), (yyvsp[-3].pred_sign), (yyvsp[-1].pred_ctrl), CISAlineno);
    }
#line 4008 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 223: /* PredSign: %empty  */
#line 1509 "CISA.y"
                 {(yyval.pred_sign) = PredState_NO_INVERSE;}
#line 4014 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 224: /* PredSign: BANG  */
#line 1509 "CISA.y"
                                                     {(yyval.pred_sign) = PredState_INVERSE;}
#line 4020 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 225: /* PredCtrlOpt: %empty  */
#line 1511 "CISA.y"
                    {(yyval.pred_ctrl) = PRED_CTRL_NON;}
#line 4026 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 227: /* SatModOpt: %empty  */
#line 1514 "CISA.y"
                  {(yyval.sat) = false;}
#line 4032 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 228: /* SatModOpt: SAT  */
#line 1514 "CISA.y"
                                      {(yyval.sat) = true;}
#line 4038 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 229: /* SrcModifier: SRCMOD_NEG  */
#line 1517 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 4044 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 230: /* SrcModifier: SRCMOD_ABS  */
#line 1518 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 4050 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 231: /* SrcModifier: SRCMOD_NEGABS  */
#line 1519 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 4056 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 232: /* SrcModifier: SRCMOD_NOT  */
#line 1520 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 4062 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 233: /* ConditionalModifier: %empty  */
#line 1522 "CISA.y"
                            {(yyval.cond_mod) = ISA_CMP_UNDEF;}
#line 4068 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 235: /* VecDstOperand_A: DstAddrOperand  */
#line 1527 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4074 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 236: /* VecDstOperand_G: DstGeneralOperand  */
#line 1528 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 4080 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 237: /* VecDstOperand_G_I: DstGeneralOperand  */
#line 1530 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 4086 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 238: /* VecDstOperand_G_I: DstIndirectOperand  */
#line 1531 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 4092 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 240: /* VecSrcOperand_G_I_IMM_A_AO: SrcAddrOfOperand  */
#line 1536 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 4098 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 242: /* VecSrcOperand_G_I_IMM_A: SrcAddrOperand  */
#line 1540 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4104 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 244: /* VecSrcOperand_G_I_IMM: SrcIndirectOperand  */
#line 1544 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 4110 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 245: /* VecSrcOperand_G_I_IMM: SrcImmOperand  */
#line 1545 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4116 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 247: /* VecSrcOperand_G_IMM: SrcImmOperand  */
#line 1549 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4122 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 249: /* VecSrcOperand_G_IMM_AO: SrcImmOperand  */
#line 1553 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4128 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 250: /* VecSrcOperand_G_IMM_AO: SrcAddrOfOperand  */
#line 1554 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 4134 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 252: /* VecSrcOperand_G_A: SrcAddrOperand  */
#line 1558 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4140 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 254: /* VecSrcOperand_G_A_AO: SrcAddrOfOperand  */
#line 1562 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4146 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 255: /* VecSrcOperand_G: SrcGeneralOperand  */
#line 1564 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 4152 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 256: /* VMEOpndIME: LPAREN DEC_LIT COMMA DEC_LIT RPAREN  */
#line 1577 "CISA.y"
    {
        (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].intval);
        (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].intval);
    }
#line 4161 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 257: /* VMEOpndFBR: LPAREN VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM RPAREN  */
#line 1584 "CISA.y"
    {
        (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
    }
#line 4171 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 258: /* SrcStateOperand: Var LPAREN IntExp RPAREN  */
#line 1592 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, false));
    }
#line 4181 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 259: /* DstStateOperand: Var LPAREN IntExp RPAREN  */
#line 1600 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, true));
    }
#line 4191 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 261: /* RawOperand: BUILTIN_NULL DOT DEC_LIT  */
#line 1631 "CISA.y"
    {
        MUST_HOLD((yyvsp[0].intval) == 0, "%null must have 0 as offset");
        (yyval.RawVar) = pBuilder->CISA_create_RAW_NULL_operand(CISAlineno); // can't fail
    }
#line 4200 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 262: /* RawOperandNonNull: VarNonNull RawOperandOffsetSuffix  */
#line 1638 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[-1].string), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 4208 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 263: /* RawOperandOffsetSuffix: DOT DEC_LIT  */
#line 1649 "CISA.y"
                {
        MUST_HOLD((yyvsp[0].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4217 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 264: /* RawOperandOffsetSuffix: DOT LPAREN IntExp RPAREN  */
#line 1654 "CISA.y"
                             {
        MUST_HOLD((yyvsp[-1].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 4226 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 265: /* RawOperandArray: %empty  */
#line 1662 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 4234 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 266: /* RawOperandArray: RawOperandArray RawOperand  */
#line 1667 "CISA.y"
    {
        rawOperandArray[(yyvsp[-1].intval)++] = (VISA_RawOpnd*)(yyvsp[0].RawVar);
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 4243 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 267: /* DstAddrOperand: AddrVarAccessWithWidth  */
#line 1675 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
          pBuilder->CISA_set_address_operand(
            (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true, CISAlineno));
    }
#line 4253 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 268: /* DstGeneralOperand: Var TwoDimOffset DstRegion  */
#line 1683 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 4262 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 269: /* DstGeneralOperand: Var DstRegion  */
#line 1688 "CISA.y"
                  {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-1].string), 0, 0, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 4271 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 270: /* DstIndirectOperand: IndirectVarAccess DstRegion DataType  */
#line 1694 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_indirect_dst(
            (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (unsigned short)(yyvsp[-1].intval), (yyvsp[0].type), CISAlineno));
    }
#line 4280 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 271: /* SrcAddrOfOperand: AddrOfVar  */
#line 1715 "CISA.y"
              {
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0, CISAlineno);
    }
#line 4288 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 272: /* SrcAddrOfOperand: AddrOfVar LBRACK IntExp RBRACK  */
#line 1719 "CISA.y"
                                   {
         MUST_HOLD((short)(yyvsp[-1].intval) == (yyvsp[-1].intval), "variable address offset is too large");
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[-3].regAccess).cisa_decl, (short)(yyvsp[-1].intval), CISAlineno);
    }
#line 4297 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 273: /* AddrOfVar: AMP Var  */
#line 1725 "CISA.y"
            {
        // Both GENERAL_VAR and SURFACE_VAR are addressable
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.regAccess).cisa_decl == nullptr)
            PARSE_ERROR("unbound variable");
        (yyval.regAccess).row = 0;
        (yyval.regAccess).elem = 0;
    }
#line 4310 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 274: /* SrcAddrOperand: AddrVarAccessWithWidth  */
#line 1736 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_set_address_operand(
                (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false, CISAlineno));
    }
#line 4320 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 275: /* SrcGeneralOperand: Var TwoDimOffset SrcRegionDirect  */
#line 1744 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 4330 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 276: /* SrcGeneralOperand: SrcModifier Var TwoDimOffset SrcRegionDirect  */
#line 1751 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno));
    }
#line 4340 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 277: /* SrcImmOperand: IntExpUnr DataTypeIntOrVector  */
#line 1761 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed((yyvsp[-1].intval), (yyvsp[0].type), CISAlineno);
    }
#line 4348 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 278: /* SrcImmOperand: HEX_LIT HFTYPE  */
#line 1766 "CISA.y"
                     {
        MUST_HOLD((yyvsp[-1].intval) < 0x10000, "literal too large for half float");
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed(
            (unsigned short)(yyvsp[-1].intval), ISA_TYPE_HF, CISAlineno);
    }
#line 4358 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 279: /* SrcImmOperand: FloatLit  */
#line 1774 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 4366 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 280: /* SrcImmOperand: MINUS FloatLit  */
#line 1777 "CISA.y"
                     {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 4374 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 281: /* SrcImmOperand: DoubleFloatLit  */
#line 1783 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 4382 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 282: /* SrcImmOperand: MINUS DoubleFloatLit  */
#line 1787 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 4390 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 284: /* FloatLit: DEC_LIT FTYPE  */
#line 1794 "CISA.y"
   {
        // "1:f" means 1.4e-45
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 4401 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 285: /* FloatLit: HEX_LIT FTYPE  */
#line 1801 "CISA.y"
   {
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 4411 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 287: /* DoubleFloatLit: DEC_LIT DFTYPE  */
#line 1809 "CISA.y"
                    {
        // "1:df" means 5e-324
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 4422 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 288: /* DoubleFloatLit: HEX_LIT DFTYPE  */
#line 1815 "CISA.y"
                    {
        // to support 0x7ff0000000000000:df
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 4433 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 289: /* SrcIndirectOperand: IndirectVarAccess SrcRegionIndirect DataType  */
#line 1826 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 4444 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 290: /* SrcIndirectOperand: SrcModifier IndirectVarAccess SrcRegionIndirect DataType  */
#line 1834 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 4455 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 291: /* DstRegion: LANGLE IntExpNRA RANGLE  */
#line 1843 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "Dst HorzStride must be 0, 1, 2, or 4");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 4465 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 292: /* SrcRegionDirect: LANGLE IntExp SEMI IntExp COMMA IntExpNRA RANGLE  */
#line 1861 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-5].intval) == 0 || (yyvsp[-5].intval) == 1 || (yyvsp[-5].intval) == 2 || (yyvsp[-5].intval) == 4 || (yyvsp[-5].intval) == 8 || (yyvsp[-5].intval) == 16 || (yyvsp[-5].intval) == 32),
                 "Src Region VertStride must be 0, 1, 2, 4, 8, 16, or 32");
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Src Region Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "Src Region HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].intval);
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 4481 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 294: /* SrcRegionIndirect: LANGLE IntExp COMMA DEC_LIT RANGLE  */
#line 1878 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 4495 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 295: /* SrcRegionIndirect: LANGLE IntExpNRA RANGLE  */
#line 1889 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = -1;
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 4507 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 296: /* IndirectVarAccess: IND_LBRACK AddrVarAccess COMMA IntExp RBRACK  */
#line 1899 "CISA.y"
                                                 {
        (yyval.regAccess) = (yyvsp[-3].regAccess);
        (yyval.regAccess).immOff = (int)(yyvsp[-1].intval);
    }
#line 4516 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 297: /* IndirectVarAccess: IND_LBRACK AddrVarAccess RBRACK  */
#line 1904 "CISA.y"
                                                 {
          (yyval.regAccess) = (yyvsp[-1].regAccess);
          (yyval.regAccess).immOff = 0;
    }
#line 4525 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 298: /* TwoDimOffset: LPAREN IntExp COMMA IntExp RPAREN  */
#line 1909 "CISA.y"
                                                {
        MUST_HOLD((yyvsp[-3].intval) >= 0, "row (register) offset must be positive");
        (yyval.offset).row = (int)(yyvsp[-3].intval);
        MUST_HOLD((yyvsp[-1].intval) >= 0 && (yyvsp[-1].intval) <= 0xFFFF, "sub-register offset out of bounds");
        (yyval.offset).elem = (int)(yyvsp[-1].intval);
    }
#line 4536 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 299: /* PredVar: Var  */
#line 1917 "CISA.y"
        {
        (yyval.vISADecl) = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.vISADecl) == nullptr)
            PARSE_ERROR((yyvsp[0].string), ": undefined predicate variable");
        if ((yyval.vISADecl)->type != PREDICATE_VAR)
            PARSE_ERROR((yyvsp[0].string), ": not a predicate variable");
    }
#line 4548 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 300: /* AddrVarAccess: Var LPAREN IntExp RPAREN  */
#line 1926 "CISA.y"
                             {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-3].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-3].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-3].string), ": not an address variable");
        }
        (yyval.regAccess).row = 1;
        (yyval.regAccess).elem = (int)(yyvsp[-1].intval);
    }
#line 4563 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 301: /* AddrVarAccessWithWidth: Var LPAREN IntExp RPAREN LANGLE IntExpNRA RANGLE  */
#line 1938 "CISA.y"
                                                     {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-6].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-6].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-6].string), ": not an address variable");
        }
        (yyval.regAccess).row = (int)(yyvsp[-1].intval);
        (yyval.regAccess).elem = (int)(yyvsp[-4].intval);
    }
#line 4578 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 302: /* SIMDMode: %empty  */
#line 1952 "CISA.y"
           {(yyval.intval) = 0;}
#line 4584 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 303: /* SIMDMode: LPAREN DEC_LIT RPAREN  */
#line 1955 "CISA.y"
    {
       MUST_HOLD(((yyvsp[-1].intval) == 8 || (yyvsp[-1].intval) == 16 || (yyvsp[-1].intval) == 32),
                 "SIMD mode can only be 8, 16, or 32");
       (yyval.intval) = (yyvsp[-1].intval);
    }
#line 4594 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 304: /* ElemNum: DOT DEC_LIT  */
#line 1966 "CISA.y"
    {
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4602 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 305: /* ExecSize: LPAREN ExecSizeInt RPAREN  */
#line 1978 "CISA.y"
    {
        (yyval.emask_exec_size).emask = vISA_EMASK_M1;
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 4611 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 306: /* ExecSize: LPAREN Var COMMA ExecSizeInt RPAREN  */
#line 1984 "CISA.y"
    {
        if (!ParseEMask(pBuilder, (yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
            PARSE_ERROR("invalid execution offset info");
        }
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 4622 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 307: /* ExecSizeInt: DEC_LIT  */
#line 1992 "CISA.y"
    {
        if ((yyvsp[0].intval) != 1 && (yyvsp[0].intval) != 2 && (yyvsp[0].intval) != 4 && (yyvsp[0].intval) != 8 && (yyvsp[0].intval) != 16 && (yyvsp[0].intval) != 32) {
            PARSE_ERROR("invalid execution size");
        }
        (yyval.intval) = (unsigned short)(yyvsp[0].intval);
    }
#line 4633 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 313: /* IntExpCond: IntExpAND QUESTION IntExpAND COLON IntExpCond  */
#line 2006 "CISA.y"
                                                    {(yyval.intval) = (yyvsp[-4].intval) ? (yyvsp[-2].intval) : (yyvsp[0].intval);}
#line 4639 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 315: /* IntExpAND: IntExpAND AMP IntExpXOR  */
#line 2009 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) & (yyvsp[0].intval);}
#line 4645 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 317: /* IntExpXOR: IntExpXOR CIRC IntExpOR  */
#line 2012 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) ^ (yyvsp[0].intval);}
#line 4651 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 319: /* IntExpOR: IntExpOR PIPE IntExpCmp  */
#line 2015 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval);}
#line 4657 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 321: /* IntExpCmp: IntExpRel EQ IntExpRel  */
#line 2018 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) == (yyvsp[0].intval);}
#line 4663 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 322: /* IntExpCmp: IntExpRel NEQ IntExpRel  */
#line 2019 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) != (yyvsp[0].intval);}
#line 4669 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 324: /* IntExpRel: IntExpNRA LANGLE IntExpNRA  */
#line 2022 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) < (yyvsp[0].intval);}
#line 4675 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 325: /* IntExpRel: IntExpNRA RANGLE IntExpNRA  */
#line 2023 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) > (yyvsp[0].intval);}
#line 4681 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 326: /* IntExpRel: IntExpNRA LEQ IntExpNRA  */
#line 2024 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) <= (yyvsp[0].intval);}
#line 4687 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 327: /* IntExpRel: IntExpNRA GEQ IntExpNRA  */
#line 2025 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) >= (yyvsp[0].intval);}
#line 4693 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 330: /* IntExpShift: IntExpAdd SHL IntExpAdd  */
#line 2046 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) << (yyvsp[0].intval);}
#line 4699 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 331: /* IntExpShift: IntExpAdd SHRS IntExpAdd  */
#line 2047 "CISA.y"
                               {(yyval.intval) = (int64_t)(yyvsp[-2].intval) >> (int)(yyvsp[0].intval);}
#line 4705 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 332: /* IntExpShift: IntExpAdd SHRZ IntExpAdd  */
#line 2048 "CISA.y"
                               {(yyval.intval) = (int64_t)((uint64_t)(yyvsp[-2].intval) >> (uint64_t)(yyvsp[0].intval));}
#line 4711 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 334: /* IntExpAdd: IntExpAdd PLUS IntExpMul  */
#line 2051 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) + (yyvsp[0].intval);}
#line 4717 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 335: /* IntExpAdd: IntExpAdd MINUS IntExpMul  */
#line 2052 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) - (yyvsp[0].intval);}
#line 4723 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 337: /* IntExpMul: IntExpMul TIMES IntExpUnr  */
#line 2055 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) * (yyvsp[0].intval);}
#line 4729 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 338: /* IntExpMul: IntExpMul SLASH IntExpUnr  */
#line 2056 "CISA.y"
                                {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) / (yyvsp[0].intval);
        }
#line 4739 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 339: /* IntExpMul: IntExpMul PERCENT IntExpUnr  */
#line 2061 "CISA.y"
                                  {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) % (yyvsp[0].intval);
        }
#line 4749 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 341: /* IntExpUnr: MINUS IntExpUnr  */
#line 2068 "CISA.y"
                      {(yyval.intval) = -(yyvsp[0].intval);}
#line 4755 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 342: /* IntExpUnr: TILDE IntExpUnr  */
#line 2069 "CISA.y"
                      {(yyval.intval) = ~(yyvsp[0].intval);}
#line 4761 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 343: /* IntExpUnr: BANG IntExpUnr  */
#line 2070 "CISA.y"
                      {(yyval.intval) = !((yyvsp[0].intval));}
#line 4767 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 347: /* IntExpPrim: LPAREN IntExp RPAREN  */
#line 2078 "CISA.y"
                           {(yyval.intval) = (yyvsp[-1].intval);}
#line 4773 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 348: /* IntExpPrim: BUILTIN_SIZEOF IDENT  */
#line 2082 "CISA.y"
                           {
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[0].string), (yyval.intval)));
    }
#line 4782 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 349: /* IntExpPrim: BUILTIN_SIZEOF LPAREN IDENT RPAREN  */
#line 2086 "CISA.y"
                                         {
        // TODO: %AlignOf(...), %Max(..)
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), (yyval.intval)));
    }
#line 4792 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;

  case 350: /* IntExpPrim: BUILTIN_DISPATCH_SIMD_SIZE  */
#line 2092 "CISA.y"
                                 {
        // e.g. %DispatchSimdSize
        // N.B. %sizeof happens above
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_lookup_builtin_constant(CISAlineno, "%DispatchSimd", (yyval.intval)));
    }
#line 4803 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"
    break;


#line 4807 "/tmp/B.v8b6wE/BUILD/intel-graphics-compiler-igc-1.0.7423/build/IGC/visa/CISA.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pBuilder, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (pBuilder, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2110 "CISA.y"

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Utility Functions                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void CISAerror(CISA_IR_Builder* pBuilder, char const *s)
{
    pBuilder->RecordParseError(CISAlineno, s);
}

static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0 || strcmp(sym, "2GRF") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "wordx32") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "wordx64") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}


static VISA_Align AlignBytesToVisaAlignment(int bytes)
{
    VISA_Align val = ALIGN_UNDEF;
    switch (bytes) {
    case 1:   val = ALIGN_BYTE; break;
    case 2:   val = ALIGN_WORD; break;
    case 4:   val = ALIGN_DWORD; break;
    case 8:   val = ALIGN_QWORD; break;
    case 16:  val = ALIGN_OWORD; break;
    case 32:  val = ALIGN_HWORD; break;
    case 64:  val = ALIGN_32WORD; break;
    case 128: val = ALIGN_64WORD; break;
    default:  val = ALIGN_UNDEF; break;
    }
    return val;
}



static bool ParseEMask(
    CISA_IR_Builder* pBuilder,
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

